{$A+,B+,D-,E-,F-,G+,I-,L-,N-,O-,R-,S-,V-,X+}
unit graphics;
{****************************************************************************
 * Author   : Stefan Goehler,Germany                                        *
 * Version  : official 1.25                                                 *
 * Task     : Replacing the unit graph with more speed and features         *
 * Sources  : C'T 2/97, Type one's t1-svga1.zip.. availible from:           *
 *            www.cdrom.com\pub\demos\code\video .. and in Imphobia 12 and  *
 *            last but not least my own work ;)                             *
 * Copyright : Do what u want to do with this, but mention me!              *
 *             But if you want to use it in commercial products - I mean if *
 *             you want to get any money for the software with this unit,   *
 *             contact me and I'll give you my OK or not                    *
 * Comments :-have fun, it's only to 70,333 percent compatible with unit    *
 *            graph ;)                                                      *
 *           -if u think, the pascal routines are slow.. I already tried to *
 *            rewrite some to assembler with only little speedup (2 %)      *
 ********                                                                   *
 * Unit in exchange for unit graph with much more performance than any BGI- *
 * driver, cause it uses faster algorythms and 386 instructions. You are azo*
 * able to use more than one graphical page (to be exact: as many as pages  *
 * your card allows). There's also border-clipping for the most of the      *
 * operations. OK... it's not new.. the unit graph cuts most operations on  *
 * the edges.. but take a look at my putimage-operation. If a part of an    *
 * image wents over an edge, it's not invisible. It's clipped on the edges. *
 * If you think this work is lame... just try yourself writing such things. *
 * But I have to say: I'm not the best...                                   *
 ********                                                                   *
 *downloaded from SourceNET: http://www.geocities.com/SiliconValley/Bay/9553*
 *if you have additions, tips or sth. else, mail to goehler@geocities.com   *
 ********                                                                   *
 * the following files you should get with this unit:                       *
 * atrax   .chs : font                                                      *
 * dets3   .pas : unit to detect s3 cards                                   *
 * littn2  .chs : font (vector, scaleable), similar to litt.chr             *
 * littn2  .obj : ^this font to compile it with this unit                   *
 * s3speed .pas : unit for speeding up s3-cards                             *
 * speedram.pas : speed up cirrus cards- shouldn't be used automaticly-some-*
 *                times it hangs the computer - let the user switch it on   *
 * hyena   .chs : new 8 Bit font containing the bitmapped font hyena        *
 * sys16x16.chs : standard 80x25-font                                       *
 * sysfont2.chs : standard graph-font                                       *
 * sysfont2.obj : ^this font to compile it with this unit                   *
 * bold    .chs : a thick letter font                                       *
 ********                                                                   *
 * History now at the end of the file                                       *
 ****************************************************************************}
interface
{$IFDEF DPMI}
uses crt,winapi,s3speed,speedram,dets3;
{$ELSE}
uses crt,s3speed,speedram,dets3;
{$ENDIF}
Type
  ColorRec = record
    r,g,b: shortint;
  end;

  PointType = record
    x,y : integer;
  end;

  pchar = ^char;    {for tp 6.0}
  PalType = array[0..255] of ColorRec;

  vesainfo = record
    VESASignature: array[0..3] of char;
    VESAVersion : word;
    OEMStringPtr: pchar;
    Capabilities: longint;
    VideoModePtr: Pointer;
    totalmemory : word;
    {beware - this will only be filled if VBE 2 or above is available}
    OemSoftwareRev   : word;
    OemVendorNamePtr : pchar;
    OemProductNamePtr: pchar;
    OemProductRevPtr : pchar;
    reserved    : array[1..222] of byte;
    OemData     : array[1..256] of byte;
  end;

  modeinfo = record
    ModeAttributes     : word;
    WinAAttributes     : byte;
    WinBAttributes     : byte;
    WinGranularity     : word;
    Winsize            : word;
    WinASegment        : word;
    WinBSegment        : word;
    WinFuncPtr         : pointer;
    BytesPerScanLine   : word;
    XResolution        : word;
    YResolution        : word;
    XCharsize          : byte;
    YCharsize          : byte;
    NumberOfPlanes     : byte;
    BitsPerPixel       : byte;
    NumberOfBanks      : byte;
    MemoryModel        : byte;
    BankSize           : byte;
    NumberOfImagePages : byte;
    Reserved1          : byte;
    RedMaskSize        : byte;
    RedFieldPosition   : byte;
    GreenMaskSize      : byte;
    GreenFieldPosition : byte;
    BlueMaskSize       : byte;
    BlueFieldPosition  : byte;
    RsvdMaskSize       : byte;
    RsvdFieldPosition  : byte;
    DirectColorModeInfo: byte;
    {VBE 2 Variables}
    PhysBasePtr        : pointer;
    OffScreenMemOffset : pointer;
    OffScreenMemSize   : word;
    Reserved          : array[1..206] of byte;
  end;

  ViewPortType = record
    x1,y1,x2,y2 : integer;
    mxx,mxy     : word;
    clip        : boolean;
  end;

var
  Pal              :^PalType;
  g,m,svga         : integer;
  mxx,mxy,maxx,maxy: integer;
  s                : string ;
  gfx_inited       : boolean;
  viewport         : viewporttype;{current viewport-settings}
  viewporton       : boolean;{says that setviewport setted viewport}
  graphresult      : integer;{will be filled in some future versions}
  winfuncptr       : pointer ;
  bitsperpixel     : byte    ;
  bytesperscanline : word    ;
  shifter          : byte    ;
  writeptr,readptr : word    ;
  vesainfoblock    : vesainfo;
  modeinfoblock    : modeinfo;
  twowins          : boolean ;
  compmode         : boolean ;

const
  lastbank    : word = 65535;
  pageadd     : word = 0;
  numofpages  : byte = 0;
  currentcolor: byte = white;
  fillcolor   : byte = white;
  on  = true;
  off = false;

  normalput  = 0;
  copyput    = 0;
  xorput     = 1;
  orput      = 0;
  andput     = 0;
  notput     = 0;

  Black        = 0;
  Blue         = 1;
  Green        = 2;
  Cyan         = 3;
  Red          = 4;
  Magenta      = 5;
  Brown        = 6;
  LightGray    = 7;
  DarkGray     = 8;
  LightBlue    = 9;
  LightGreen   = 10;
  LightCyan    = 11;
  LightRed     = 12;
  LightMagenta = 13;
  Yellow       = 14;
  White        = 15;

{Fillsettings - maybe i'll implement a support for it soon}
  EmptyFill     =  0;
  SolidFill     =  1;
  LineFill      =  2;
  LtSlashFill   =  3;
  SlashFill     =  4;
  BkSlashFill   =  5;
  LtBkSlashFill =  6;
  HatchFill     =  7;
  XHatchFill    =  8;
  InterleaveFill=  9;
  WideDotFill   =  10;
  CloseDotFill  =  11;
  UserFill      =  12;

{Font constants}
  DefaultFont  = 0;
  TriplexFont  = 2;
  SmallFont    = 2;
  SansSerifFont= 2;
  GothicFont   = 2;
  HorizDir     = 0;
  VertDir      = 1;
  UserCharSize = 0;
{Settextjustify-constants}
{Horizontal}
  LeftText     = 0;
  RightText    = 2;
{Vertikal}
  ButtomText   = 0;
  TopText      = 2;
{vertikal and horizontal}
  CenterText   = 1;
{constants for setviewport}
  ClipOn       = True;
  ClipOff      = False;

  textx : word = lefttext;
  texty : word = toptext;


  speedupS3  : boolean = true;
  speedupws  : boolean = false;
  S3         : boolean = false;

  currentsize : byte = 1;
  font        : byte = 0;



  modeset : array[0..6] of record
   mode,sx,sy : word;
   end=((mode:$013;sx:0319;sy:0199),
        (mode:$100;sx:0639;sy:0399),
        (mode:$101;sx:0639;sy:0480),
        (mode:$103;sx:0799;sy:0599),
        (mode:$105;sx:1023;sy:0767),
        (mode:$107;sx:1279;sy:1023),
        (mode:$120;sx:1599;sy:1199));{maybe that's not the same on all cards}

type
  chartype = array[0..255] of record
    numofpoints : byte;
    pointpos : array[0..15] of record
      x,y      : byte;
      stopline : boolean;
      reserved : byte;
    end;
  end;

var
  header : array[0..3] of record
    kennung               : string[11];
    version               : word;
    name                  : string[20];
    charsize,height,width : byte;
    chartype              : byte;{1= Vektor;2= Bitmap;3=Bitmapped truetype}
    colordepth            : byte;
    startchar,endchar     : word;
    distance              : byte;
    memsize               : word;
    reserved              : array[0..16] of byte;
  end;

  chars  : array[0..3] of pointer;
  charpoints : chartype;

  point  : array[0..499] of word;{radius of a circle cannot be larger than 500 points}
  oldcol : byte;

{TEXTMODE-functions for GFX/TEXTMODES}
{procedure textcolor(c : byte);
 procedure clrscr;
 procedure writeln(s : string);
 procedure write(s : string);}

 function GetRMSelector(segment : word) : word;

 procedure settext;
 procedure gettext;

{Palette-functions}
 procedure getpal;
 procedure setpal;
 procedure shiftpal;
 procedure getuserpal(var pal);
 procedure setuserpal(var pal);
 procedure setrgbpalette(i,r,g,b : byte);
 procedure setrgbpal(i,r,g,b : byte);
 procedure getrgbpal(i : byte;var r,g,b : byte);
 procedure settextstyle(font,direction,charsize: word);
 procedure GetRGBpalette (color : byte; var r, g, b : byte);
 function  findnearcol(nr,ng,nb : byte) : byte;
 procedure loadjascpal(path : string);

 procedure getvesamodeinfo;
 procedure set256mode(mode : integer);
 function  getmaxmode: integer;
 procedure closegraph;
 procedure waitretrace;
 procedure pageretrace;
 procedure hretrace;
 procedure setscreen(on : boolean);
 procedure setviewport(x1,y1,x2,y2 : integer;clip : boolean);
 procedure getviewsettings(var viewport : viewporttype);
 procedure clearviewport;

{graphical functions}
 procedure getimagesize(p : pointer;var x,y : word);
 procedure setimagesize(p : pointer;x,y : word);
 function  imagesize(x1,y1,x2,y2 : word) : word;
 procedure scale(image : pointer;px,py,sx,sy : word);
 procedure stretch(image : pointer;width,sx : word);
 procedure putpixel(x,y :word;color : byte);
 function  getpixel(x,y :word) : byte;
 procedure putimage(x,y: integer;p : pointer);
 procedure putsprite(x,y: integer;p : pointer);
 procedure getimage(x,y,x2,y2 : integer;p : pointer);
 procedure bar(x1,y1,x2,y2: integer);
 procedure rbar(x1,y1,x2,y2 :integer;r:word);
 procedure fillcircle(x,y :integer;r:word);
 procedure circle(px,py :integer;r:word);
 procedure hline(x1,y1,sizex: integer;col : byte);
 procedure vline(x1,y1,sizey: integer;col : byte);
 procedure putline(x1,y1,sizex: integer;p : pointer);
 procedure getline(x1,y1,sizex: integer;p : pointer);
 procedure progline(x,y: integer;sizex,mempos : word;p : pointer);
 procedure line(x1,y1,x2,y2: integer);
 procedure rectangle(x1,y1,x2,y2: integer);
 procedure rrectangle(x1,y1,x2,y2 :integer;r:word);
 procedure cleardevice;
 procedure floodfill(x,y:integer; border:byte);

{Text-functions}
 procedure settextjustify(Horiz, Vert: Word);
 procedure readgraphline(x1,y1,col,maxchars,posx : word;var s2 : string);
 procedure outtextxy(x,y : integer;s : string);
 procedure setfont(fnt,size : byte);
 procedure writexy(x,y : integer;s : string);
 function  makestr(w : longint) : String;
 function  makestrr(r : real;sh,st : byte) : String;
 function  textwidth(s : string) : word;
 function  textheight : word;
 function  loadfont(name : string;num : byte) : boolean;
 function  loadfontmem(p : pointer;num : byte) : boolean;

 procedure move2(var input,output;size : word);
 procedure sprite2mem(var input,output;size : word);
{procedure moveQ(var input,output;size : word);}
 procedure move2screen(var input,output;size : word);
 procedure movefromscreen(var input,output;size : word);
 procedure FillDWord(var dest; Times : word;data : byte);
 procedure cls(dest : pointer);
 procedure setactivepage(page : byte);
 procedure setvisualpage(page : word);
 procedure scroll(ypos : word);
 procedure setcolor(col : byte);
 function  getcolor : byte;
 procedure setfillstyle(pattern: word; col: byte);
 procedure setfillcolor(col: byte);

 procedure setwritemode(mode : byte);

 procedure setbank(bank : word);
 function  getbank : word;
 procedure setbank2(bank : word);
 procedure incbank;
 procedure decbank;
 function  getmaxx : word;
 function  getmaxy : word;
 function  getmaxcolor : word;
 function  calcbank(x,y : integer) : word;
 procedure change(var i1,i2 : integer);
 procedure calccircle(r : integer);

implementation
var
  load,i : integer;
  screen : pointer;
  getted : boolean;
  cpos   : record
    x,y  : integer;
  end;
  actpage : byte;


{crspos : record
x,y : word;
end;
lastcol : byte;
const
txtcol : byte = lightgray;

procedure textcolor(c : byte);
begin
if not gfx_inited then crt.textcolor(c) else
txtcol := c;
end;

procedure clrscr;
begin
if not gfx_inited then crt.clrscr
else begin
cleardevice;
crspos.x := 0;
crspos.y := 0;
end;
end;

procedure scrolltext;
var
p : pointer;
y : word;
begin
getmem(p,maxx*8+4);
for y := 0 to maxy div 8-1 do begin
getimage(0,y*8+8,mxx,y*8+16,p);
putimage(0,y*8,p);
end;
freemem(p,maxx*8+4);
bar(0,(maxy div 8)*8,mxx,mxy);
end;

procedure writeln(s : string);
begin
if not gfx_inited then system.writeln(s)
else begin
lastcol := getcolor;
setcolor(txtcol);
setfont(0,0);
if crspos.y > maxy div 8-1 then begin
scrolltext;
crspos.y :=  maxy div 8-1;
end;
writexy(crspos.x*8,crspos.y*8,s);
inc(crspos.y);
crspos.x := 0;
setcolor(lastcol);
end;
end;

procedure write(s : string);
begin

if not gfx_inited then system.write(s)
else begin
lastcol := getcolor;
setcolor(txtcol);
setfont(0,0);
writexy(crspos.x*8,crspos.y*8,s);
inc(crspos.x,length(s));
setcolor(lastcol);
end;
end;}

Procedure cls(dest : pointer);assembler;
{a little clearer for images getted
with getimage or sized with setimagesize}
asm
 les  di,dest
 mov  ax,es:[di]
 inc  ax
 add  di,2
 mov  bx,es:[di]
 inc  bx
 mul  bx
 mov  cx,ax
 mov  bx,ax
 shr  cx,2
 add  di,2
 db   66h;xor ax,ax
 db   0F3h,66h,0ABh{rep stosd}
 mov  cx,bx
 and  cx,11b
 jz   @end
 rep  stosb
 @end:
end;


procedure moveQ(var input,output;size : word);assembler;
{B careful-won't work at all because I don't know the
 OpCode of one instruction}
asm
 push ds
 lds  si,input
 les  di,output
 mov  cx,size
 mov  ax,cx
 cmp  ax,16
 jb   @not16
 shr  cx,4
 @lp:
   db $DF,$2C          {fild   qword ptr[si]}
   db $DF,$3D          {fistp  qword ptr[di]}
   db $DF,$6C,$08      {fild   qword ptr[si+8]}
   db $DF,$7D,$08      {fistp  qword ptr[di+8]}
   add si,16
   add di,16
   dec cx
 jnz @lp
 @not16:
 mov  cx,ax
 and  cx,1111b
 mov  ax,cx
 shr  cx,2
 db   0F3h,66h,0A5h{rep movsd}
 mov  cx,ax
 and  cx,11b
 jz   @end
 @no4:
 rep  movsb
 @end:
 pop  ds
End;

procedure move2(var input,output;size : word);assembler;
{use it instead of the normal move.. size is to set in bytes}
asm
 mov  dx,ds
 lds  si,input
 les  di,output
 mov  cx,size
 mov  ax,cx
 shr  cx,2
 jz   @not4
 db   0F3h,66h,0A5h{rep movsd}
 @not4:
 mov  cx,ax
 and  cx,11b
 jz   @end
 rep  movsb
 @end:
 mov  ds,dx
end;

procedure move2screen(var input,output;size : word);assembler;
{optimized for 32-Bit address output}
asm
 mov  dx,ds
 lds  si,input
 les  di,output
 mov  cx,size
 mov  ax,cx
 cmp  cx,8
 jb   @start
 mov  cx,di
 and  cx,11b
 jz   @iszero
 mov  bx,4
 sub  bx,cx
 mov  cx,bx
 rep  movsb
 sub  ax,bx
 @iszero:
 mov  cx,ax
 @start:
  shr  cx,2
  db   0F3h,66h,0A5h{rep movsd}
  mov  cx,ax
  and  cx,11b
  jz   @end
  rep  movsb
 @end:
 mov  ds,dx
end;

procedure movefromscreen(var input,output;size : word);assembler;
{optimized for 32-Bit address input (PCI-Bus)}
asm
 mov  dx,ds
 lds  si,input
 les  di,output
 mov  cx,size
 mov  ax,cx
 cmp  cx,8
 jb   @start
 mov  cx,si
 and  cx,11b
 jz   @iszero
 mov  bx,4
 sub  bx,cx
 mov  cx,bx
 rep  movsb
 sub  ax,bx
 @iszero:
 mov  cx,ax
 @start:
  shr  cx,2
  db   0F3h,66h,0A5h{rep movsd}
  mov  cx,ax
  and  cx,11b
  jz   @end
  rep  movsb
 @end:
 mov  ds,dx
end;


procedure FillDWord(var dest; Times : word;data : byte);assembler;
{Runs like fillchar but with dwords.. you have to set the times
 to fill in bytes. Optimized for maximal screen-output (32-Bit PCI)}
asm
 mov  al,data
 mov  ah,al
 mov  dx,ax
 db   66h;shl ax,16
 mov  ax,dx
 les  di,dest
 mov  cx,times
 or   cx,cx
 jz   @end
 mov  dx,cx
 cmp  cx,8
 jb   @start
 mov  cx,di
 and  cx,11b
 jz   @iszero
 mov  bx,4
 sub  bx,cx
 mov  cx,bx
 rep  stosb
 sub  dx,bx
 @iszero:
 mov  cx,dx
 @start:
  shr  cx,2
  db   0F3h,66h,0ABh{rep stosd}
  mov  cx,dx
  and  cx,11b
  jz   @end
  mov  al,data
  rep  stosb
 @end:
end;

procedure setactivepage(page : byte);
{sets page to draw at}
begin
 if numofpages >= page then pageadd := page*maxy;
 graphics.actpage := page;
end;

procedure setvisualpage(page : word);assembler;
{sets visible page}
asm
 mov  bx,page
 mov  ax,maxy
 mul  bx
 mov  dx,ax
 mov  al,numofpages
 cmp  al,bl
 jnae @end
 @next:
  mov  ax,4f07h
  xor  bx,bx
  xor  cx,cx
  int  10h
 @end:
end;

procedure scroll(ypos : word);assembler;
asm
 mov  dx,ypos
 mov  ax,4f07h
 xor  bx,bx
 xor  cx,cx
 int  10h
end;

{$IFDEF DPMI}
{Ripped from BGIDEMO.PAS}
type
 TRealRegs = record
   RealEDI: Longint;
   RealESI: Longint;
   RealEBP: Longint;
   Reserved: Longint;
   RealEBX: Longint;
   RealEDX: Longint;
   RealECX: Longint;
   RealEAX: Longint;
   RealFlags: Word;
   RealES: Word;
   RealDS: Word;
   RealFS: Word;
   RealGS: Word;
   RealIP: Word;
   RealCS: Word;
   RealSP: Word;
   RealSS: Word;
 end;
var
  Segment,Selector,VesaCap : Word;


procedure GetVesaInfo;
begin
 asm
  push 0000h
  push 0100h
  call globaldosalloc
  mov segment,dx
  mov selector,ax
  mov di,offset RealModeRegs
  mov word ptr [DI].TRealRegs.RealSP, 0
  mov word ptr [DI].TRealRegs.RealSS, 0
  mov word ptr [DI].TRealRegs.RealEAX, 4F00h
  mov word ptr [DI].TRealRegs.RealES, dx
  mov word ptr [DI].TRealRegs.RealEDI, 0
  mov ax,ds
  mov es,ax
  mov ax,0300h
  mov bx,0010h
  int 31h
 end;
 move2(ptr(selector,0)^,vesainfoblock,256);
 globaldosfree(selector);
end;

{$ELSE}
procedure getvesainfo;assembler;
asm
 mov  ax,4F00h
 mov  di,seg vesainfoblock
 mov  es,di
 mov  di,offset vesainfoblock
 int  10h
end;
{$ENDIF}


procedure fill(var dest;times,d1,d2 : word);assembler;
{fills dest with times dwords}
asm
 mov  ax,d2
 db   66h;shl ax,16
 mov  ax,d1
 les  di,dest
 mov  cx,times
 cld
 db   0F3h,66h,0ABh{rep stosd}
end;

procedure cleardevice;{guess...}
var
  w    : word   ;
  l    : longint;
begin
 calcbank(0,pageadd);
 w := pageadd*bytesperscanline;
 l := longint(bytesperscanline)*maxy;
 if w > 0 then
 filldword(ptr(writeptr,w)^,65536-w,0) else
 fill(ptr(writeptr,0)^,16384,0,0);
 dec(l,65536-w);
 repeat
   incbank;
   if l >= longint(65536) then
   fill(ptr(writeptr,0)^,16384,0,0) else
   filldword(ptr(writeptr,0)^,l,0);
   dec(l,65536);
 until l <= 0;
end;


procedure progline(x,y: integer;sizex,mempos : word;p : pointer);assembler;
{Progressive line putting- better don't use it}
asm
          mov  ax,maxx
          mov  bx,sizex
          mov  cx,x
          mov  dx,y

          cmp  cx,ax
          jnb  @end
          mov  si,cx
          add  si,bx
          js   @end
{         cmp  dx,maxy
          jnb  @end
          mov  dx,pageadd
          add  y,dx}

          or   cx,cx
          jns  @ns
          add  bx,cx
          mov  di,bx
          mov  x,0
          jmp  @cmpend
@ns:      mov  si,cx
          add  si,bx
          cmp  si,ax
          jna  @na
          sub  ax,cx
          mov  di,ax
          jmp  @cmpend
@na:      mov  di,bx
@cmpend:  mov  cx,mempos
          mov  bx,di
          add  bx,cx
          jc   @nextbank
{         push word ptr p[2]
          push word ptr p[0]
          push writeptr
          push cx
          push di
          call move2screen}
 xchg di,cx
 mov  bx,writeptr
 mov  dx,ds
 lds  si,p
 mov  es,bx
 mov  ax,cx
 cmp  cx,8
 jb  @start
 mov  cx,di
 and  cx,11b
 jz   @iszero
 mov  bx,4
 sub  bx,cx
 mov  cx,bx
 rep  movsb
 sub  ax,bx
 @iszero:
 mov  cx,ax
 @start:
  shr  cx,2
  db   0F3h,66h,0A5h{rep movsd}
  mov cx,ax
  and cx,11b
  jz @end2
  rep movsb
 @end2:
 mov ds,dx

          jmp  @end
@nextbank:mov  si,65535
          mov  ax,cx
          dec  ax
          sub  si,ax
          push si;push di
          push word ptr p[2]
          push word ptr p[0]
          push writeptr
          push cx
          push si
          call move2screen
          pop  di;pop si
          call incbank
          mov  ax,di
          sub  ax,si
          push word ptr p[2]
          mov  bx,word ptr p[0]
          add  bx,si
          push bx
          push writeptr
          push 0
          push ax
          call move2
          jmp  @next
          @end:
          mov  ax,mempos
          add  ax,bytesperscanline
          jnc  @next
          call incbank
@next:
end;

procedure stretch(image : pointer;width,sx : word);
{stretches image from width to new size(sx) - better don't use it}
var
  xtable : array[0..1023] of word;
  p      : pointer;
  x      : word;
  umrx   : longint;
begin
 getmem(p,sx+2);
 umrx := 0;
 for x := 0 to sx-1 do begin
   xtable[x] := umrx div sx;
   inc(umrx,width);
 end;
 asm
  mov cx,width

  push ds
  lds di,image

  les bx,p
  mov si,sx
  add bx,si
  add si,si

  @lp:
    mov dx,word ptr xtable[si]
    add di,dx
    mov al,ds:[di]
    sub di,dx
    mov dx,word ptr xtable[si+2]
    add di,dx
    mov ah,ds:[di]
    sub di,dx

    mov es:[bx],ax
    sub bx,2
    sub si,4
  jns @lp
  pop ds
 end;
 move2(p^,image^,sx);
 freemem(p,sx+2);
end;

procedure scale(image : pointer;px,py,sx,sy : word);
{Not very professional, but scales on my P100 with S3 Trio64
 from 160x120 to 640x480 at 82 pics per second and more (realmode)}
var
  x,y,maxx,maxy,posx,posy,old,vmempos,memsize : word;
  umrx,umry                   : longint;
  xtable                      : array[0..2047] of word;
  p                           : pointer;
begin
 if (sx = 0)or(sy = 0) then exit;
 vmempos := calcbank(px,py+pageadd);

 memsize := sx+8;
 getmem(p,memsize);
 getimagesize(image,maxx,maxy);
 umry := 0;
 umrx := 0;
{asm
   xor  dx,dx
   db   66h;xor bx,bx
   db   66h;xor cx,cx
   db   66h;xor di,di
   xor  si,si
   mov  di,maxx
   inc  di
   mov  cx,sx
   @lp:
     db   66h;mov ax,bx
     div  cx
     mov  word ptr xtable[si],ax
     db   66h;add bx,di
     add  si,2
     inc  dx
     cmp  dx,sx
  jne  @lp
 end;}
 for x := 0 to sx-1 do begin
   xtable[x] := umrx div sx;
   inc(umrx,maxx+1);
 end;
 filldword(xtable[sx],4,0);
 old := 0;
 if viewport.clip then
  if sx > viewport.mxx+1 then sx := viewport.mxx+1;

 if sx+px+viewport.x1 > graphics.maxx then sx := graphics.maxx-px-viewport.x1;

 sx := sx and $FFFE;
 if viewport.clip then
  if py+sy+viewport.y1 > viewport.mxy+1 then sy := viewport.mxy+1-py;

 if (sy < maxy) then begin
   for y := 0 to sy-1 do begin
     posy := (umry div sy);
     if old <> posy then begin
       old := posy;

       asm
        mov  cx,maxx
        inc  cx
        mov  ax,posy
        mul  cx
        add  ax,4

        cmp  old,ax
        je   @end
        mov  old,ax
        push ds

        lds  di,image
        add  di,ax

        les  bx,p
        mov  si,sx
        add  bx,si
        add  si,si

        @lp:
          mov  dx,word ptr xtable[si]
          add  di,dx
          mov  al,ds:[di]
          sub  di,dx
          mov  dx,word ptr xtable[si+2]
          add  di,dx
          mov  ah,ds:[di]
          sub  di,dx

          mov  es:[bx],ax
          sub  bx,2
          sub  si,4
        jns  @lp
        pop  ds
        @end:
       end;
       progline(px,py+y,sx,vmempos,p);
       inc(vmempos,bytesperscanline);
     end;

     inc(umry,maxy+1);
   end;
 end else
 for y := 0 to sy-1 do begin
   posy := (umry div sy);
   asm
    mov  cx,maxx
    inc  cx
    mov  ax,posy
    mul  cx
    add  ax,4

    cmp  old,ax
    je   @end
    mov  old,ax
    push ds

    lds  di,image
    add  di,ax

    les  bx,p
    mov  si,sx
    add  bx,si
    add  si,si

    @lp:
      mov  dx,word ptr xtable[si]
      add  di,dx
      mov  al,ds:[di]
      sub  di,dx
      mov  dx,word ptr xtable[si+2]
      add  di,dx
      mov  ah,ds:[di]
      sub  di,dx

      mov  es:[bx],ax
      sub  bx,2
      sub  si,4
    jns  @lp
    pop  ds
    @end:
   end;
   progline(px,py+y,sx,vmempos,p);
   inc(vmempos,bytesperscanline);

   inc(umry,maxy+1);
 end;
 freemem(p,memsize);
end;

function calcbank(x,y : integer) : word;assembler;
{calculates position x,y in GFXmem, sets bank and
 gives position out}
asm
 db   66h;xor cx,cx
 db   66h;xor ax,ax
 mov  bx,x
 add  bx,viewport.x1
 mov  ax,viewport.y1
 mov  cx,bytesperscanline
 add  ax,y
 db   66h;mul cx
 mov  cx,bx
 db   66h;add ax,cx
 mov  si,ax
 db   66h;shr ax,16
 cmp  ax,lastbank
 je   @end
 push ax
 call setbank2
@end:
 mov ax,si
end;

{$IFNDEF DPMI}
procedure calccircle(r : integer);assembler;
{calculates a circle}
asm
 push bp
 xor cx,cx
 mov dx,r
 mov bx,1
 sub bx,r
 mov si,r
 mov es,si
 mov di,si
 neg di
 add di,di
 add di,5
 mov bp,3

 sub si,dx
 add si,si
 mov word ptr point[si],cx
 mov si,es
 sub si,cx
 add si,si
 mov word ptr point[si],dx
 @lp:
   or bx,bx
   jns @ns
   mov ax,bp
   add bx,ax
   add ax,2
   mov bp,ax
   add di,2
   jmp @end
   @ns:
   mov ax,di
   add bx,ax
   add ax,4
   mov di,ax
   add bp,2
   dec dx
   @end:
   inc cx
   mov si,es
   sub si,dx
   add si,si
   mov word ptr point[si],cx
   mov si,es
   sub si,cx
   add si,si
   mov word ptr point[si],dx
   cmp dx,cx
 jg @lp
 pop bp
end;
{$ELSE}
procedure calccircle(r : integer);
var
  x,y,d,deltaE,deltaSE : integer;
begin
 x := 0;
 y := r;
 d := 1-r;
 deltaE := 3;
 deltaSE:=-r shl 1+5;
 point[r-y] := x;
 point[r-x] := y;

 while y > x do begin
  if d < 0 then begin
    inc(d,deltaE);
    inc(deltaE,2);
    inc(deltaSE,2);
    inc(x);
  end else begin
    inc(d,deltaSE);
    inc(deltaE,2);
    inc(deltaSE,4);
    inc(x);
    dec(y);
  end;
  point[r-y] := x;
  point[r-x] := y;
 end;
end;
{$ENDIF}

procedure fillcircle(x,y :integer;r:word);
{draws a filled circle}
var
  i  : integer;
begin
 dec(y,r);
 calccircle(r);
 for i := 0 to r-1 do begin
   hline(x-point[i],y,point[i] shl 1,fillcolor);
   inc(y);
 end;
 for i := r-1 downto 0 do begin
  hline(x-point[i],y,point[i] shl 1,fillcolor);
  inc(y);
  end;
end;

procedure circle(px,py :integer;r:word);
{draws a traced circle}
var
  i  : integer;
  x  : word;
begin
 dec(py,r);
 calccircle(r);
 line(px-point[0],py-1,px+point[0],py-1);
 for i := 0 to r-1 do begin
   line(px-point[i],py,px-point[i+1],py);
   line(px+point[i],py,px+point[i+1],py);
   inc(py);
 end;
 for i := r-1 downto 0 do begin
   line(px-point[i],py,px-point[i+1],py);
   line(px+point[i],py,px+point[i+1],py);
   inc(py);
 end;
 line(px-point[0],py,px+point[0],py);
end;


procedure putimage(x,y: integer;p : pointer);
var
  sizex,sizey,i,i2,i3,i4,oli2,putmaxx : word;
  switched      : boolean;
begin
 sizex := succ(MemW[Seg(p^):Ofs(p^)]);
 sizey := MemW[Seg(p^):Ofs(p^)+2];
 if longint(sizex)*sizey > 65524 then exit;
 if (x < viewport.mxx+1)and(x+sizex > 0)and(y+sizey > -1)and((y < viewport.mxy+1)or(not viewport.clip)) then begin
   if viewport.clip then
   if y+sizey > viewport.mxy then sizey := sizey+(viewport.mxy-(y+sizey));
   i4 := 4;
   if y < 0 then begin
     i4 := i4-(y*sizex);
     sizey := sizey+y;
     y := 0;
   end;
   if x < 0 then begin
     i4 := i4-x;
     putmaxx := sizex+x;
     x := 0;
   end else begin
     if viewport.clip then
     if x+sizex > viewport.mxx then putmaxx := viewport.mxx-x+1 else
     putmaxx := sizex;
   end;
   if putmaxx+x > maxx then putmaxx := maxx-x;
   inc(y,pageadd);
   i2 := calcbank(x,y);
   oli2 := i2;
   switched := false;
   for i := y to y+sizey do begin
     if i2 < i2+putmaxx then begin
       if (oli2 > i2)and(not switched) then incbank;
       move2screen(ptr(seg(p^),ofs(p^)+i4)^,ptr(writeptr,i2)^,putmaxx);
       switched := false;
     end else begin
       i3 := 65535-pred(i2);
       move2screen(ptr(seg(p^),ofs(p^)+i4)^,ptr(writeptr,i2)^,i3);
       incbank;
       switched := true;
       move2(ptr(seg(p^),ofs(p^)+i4+i3)^,ptr(writeptr,0)^,putmaxx-i3);
     end;
     inc(i4,sizex);
     oli2 := i2;
     inc(i2,bytesperscanline);
   end;
 end;
end;

{procedure putsprite(x,y: integer;p : pointer);assembler;
asm
push x
push y
call calcbank
mov si,ax
les di,p
mov bx,writeptr
mov ax,maxx
sub ax,es:[di]
push ds
mov ds,bx
mov cx,es:[di+2]
mov bx,es:[di]
add di,4
@lp1:
mov dx,bx
push ax
@lp2:
mov al,es:[di]
or al,al
jz @black;mov ds:[si],al;@black:

inc di
inc si
jnc @noinc1
pop ds
call incbank
push bx
mov bx,writeptr
push ds
mov ds,bx
pop bx
@noinc1:

dec dx
jnz @lp2
pop ax
add si,ax

jnc @noinc2
pop ds
call incbank
push bx
mov bx,writeptr
push ds
mov ds,bx
pop bx
@noinc2:

inc di
dec cx
jnz @lp1
pop ds
end;}

procedure sprite2mem(var input,output;size : word);assembler;
asm
 mov dx,ds
 les di,input
 lds si,output
 mov cx,size
 or cx,cx
 jz @end
 mov bx,cx
 or cx,cx
 shr cx,1
 jz @end
 @lp:
   mov ax,es:[di]
   or al,al
   jz @black;mov ds:[si],al;@black:
   or ah,ah
   jz @black2;mov ds:[si+1],ah;@black2:

   add di,2
   add si,2
   dec cx
 jnz @lp
 and bx,1
 jz @end
 mov al,es:[di]
 or al,al
 jz @black3;mov ds:[si],al;@black3:

 @end:
 mov ds,dx
end;


procedure putsprite(x,y: integer;p : pointer);
var
  sizex,sizey,i,i2,i3,i4,oli2,putmaxx : word;
  switched      : boolean;
begin
 sizex := succ(MemW[Seg(p^):Ofs(p^)]);
 sizey := MemW[Seg(p^):Ofs(p^)+2];
 if longint(sizex)*sizey > 65524 then exit;
 if (x < viewport.mxx+1)and(x+sizex > 0)and(y+sizey > -1)and((y < viewport.mxy+1)or(not viewport.clip)) then begin
   if viewport.clip then
   if y+sizey > viewport.mxy then sizey := sizey+(viewport.mxy-(y+sizey));
   i4 := 4;
   if y < 0 then begin
     i4 := i4-(y*sizex);
     sizey := sizey+y;
     y := 0;
   end;
   if x < 0 then begin
     i4 := i4-x;
     putmaxx := sizex+x;
     x := 0;
   end else begin
     if viewport.clip then
     if x+sizex > viewport.mxx then putmaxx := viewport.mxx-x+1 else
     putmaxx := sizex;
   end;
   if putmaxx+x > maxx then putmaxx := maxx-x;
   inc(y,pageadd);
   i2 := calcbank(x,y);
   oli2 := i2;
   switched := false;
   for i := y to y+sizey do begin
     if i2 < i2+putmaxx then begin
       if (oli2 > i2)and(not switched) then incbank;
       sprite2mem(ptr(seg(p^),ofs(p^)+i4)^,ptr(writeptr,i2)^,putmaxx);
       switched := false;
     end else begin
       i3 := 65535-pred(i2);
       sprite2mem(ptr(seg(p^),ofs(p^)+i4)^,ptr(writeptr,i2)^,i3);
       incbank;
       switched := true;
       sprite2mem(ptr(seg(p^),ofs(p^)+i4+i3)^,ptr(writeptr,0)^,putmaxx-i3);
     end;
     inc(i4,sizex);
     oli2 := i2;
     inc(i2,bytesperscanline);
   end;
 end;
end;

procedure getimage(x,y,x2,y2 : integer;p : pointer);
var
  sizex,sizey,i,i2,i3,i4,oli2,getmaxx : word;
  lastbank      : word   ;
  switched      : boolean;
  i5            : integer;
begin
 inc(y,pageadd);
 inc(y2,pageadd);
 if y > y2 then begin
   i5 := y;
   y  := y2;
   y2 := i5;
 end;
 if x > x2 then begin
   i5 := x;
   x  := x2;
   x2 := i5;
 end;
 sizex := succ(abs(x2-x));
 sizey := abs((y2-y));
 setimagesize(p,sizex-1,sizey);
 i2 := calcbank(x,y);
 oli2 := i2;
 i4 := 4;
 if x+sizex > maxx then getmaxx := maxx-x else{Fehldarstellungen am Rand!}
 getmaxx := sizex;
 if viewport.clip then
 if (y-pageadd)+sizey > mxy then sizey := sizey+(mxy-((y-pageadd)+sizey));
 switched := false;
 for i := y to y+sizey do begin
   if i2 < i2+getmaxx then begin
     if (oli2 > i2)and(not switched) then incbank;
     movefromscreen(ptr(readptr,i2)^,ptr(seg(p^),ofs(p^)+i4)^,getmaxx);
     switched := false;
   end
   else begin
     i3 := 65535-pred(i2);
     movefromscreen(ptr(readptr,i2)^,ptr(seg(p^),ofs(p^)+i4)^,i3);
     incbank;
     switched := true;
     move2(ptr(readptr,0)^,ptr(seg(p^),ofs(p^)+i4+i3)^,getmaxx-i3);
   end;
   inc(i4,sizex);
   oli2 := i2;
   inc(i2,bytesperscanline);
 end;
end;

procedure change(var i1,i2 : integer);assembler;
asm
 mov dx,ds
 les di,i1
 lds si,i2
 mov ax,es:[di]
 mov bx,ds:[si]
 mov es:[di],bx
 mov ds:[si],ax
 mov ds,dx
end;

procedure bar(x1,y1,x2,y2: integer);
var
  sizex,sizey,i,i2,i3,oli2,putmaxx : word;
  switched      : boolean;
begin
 if y1 > y2 then change(y1,y2);
 if x1 > x2 then change(x1,x2);
 sizex := succ(x2-x1);
 sizey := y2-y1;
 if (x1 < maxx)and(x1+sizex > 0)and(y1+sizey > -1)and((y1 < maxy)or(not viewport.clip)) then begin
   if viewport.clip then
   if y1+sizey > mxy then sizey := sizey+(mxy-(y1+sizey));
   if y1 < 0 then begin
     sizey := sizey+y1;
     y1 := 0;
   end;
   if x1 < 0 then begin
     putmaxx := sizex+x1;
     x1 := 0;
   end else begin
     if x1+sizex > maxx then putmaxx := maxx-x1 else putmaxx := sizex;
   end;
   inc(y1,pageadd);
   inc(y2,pageadd);
   i2 := calcbank(x1,y1);
   oli2 := i2;
   switched := false;
   for i := y1 to y1+sizey do begin
     if i2 < i2+putmaxx then begin
       if (oli2 > i2)and(not switched) then incbank;
       filldword(ptr(writeptr,i2)^,putmaxx,Fillcolor);
       switched := false;
     end
     else begin
       i3 := 65535-pred(i2);
       filldword(ptr(writeptr,i2)^,i3,Fillcolor);
       incbank;
       switched := true;
       filldword(ptr(writeptr,0)^,putmaxx-i3,Fillcolor);
     end;
     oli2 := i2;
     inc(i2,bytesperscanline);
   end;
 end;
end;

procedure rbar(x1,y1,x2,y2 : integer;r : word);
{bar with rounded edges - radius of circle is r}
var
  i,sizex  : word;
  x,y      : word;
begin
 sizex := abs(x2-x1);
 calccircle(r);
 hline(x1+r-point[0],y1,sizex-(r-point[0])*2+1,currentcolor);
 vline(x1,y1+r,y2-y1-r*2,currentcolor);
 hline(x1+r-point[0],y2,sizex-(r-point[0])*2+1,currentcolor);
 vline(x2,y1+r,y2-y1-r*2,currentcolor);
 for y := 1 to r do
 for x := r-point[y] to r-point[y-1] do begin
   putpixel(x1+x,y1+y,currentcolor);
   putpixel(x2-x,y1+y,currentcolor);
 end;
 for y := 1 to r do
 for x := r-point[y] to r-point[y-1] do begin
   putpixel(x1+x,y2-y,currentcolor);
   putpixel(x2-x,y2-y,currentcolor);
 end;
 for y := 1 to r do
 hline(x1+r-point[y-1]+1,y1+y,sizex-(r*2-point[y-1]*2)-1,fillcolor);
 bar(x1+1,y1+r+1,x2-1,y2-r-1);
 for y := r downto 1 do
 hline(x1+r-point[y-1]+1,y2-y,sizex-(r*2-point[y-1]*2)-1,fillcolor);
end;


procedure rrectangle(x1,y1,x2,y2 :integer;r:word);
{rectangle with rounded edges - radius of circle is r}
var
  i,sizex  : word;
  x,y      : word;
begin
 inc(y1,pageadd);
 inc(y2,pageadd);
 sizex := abs(x2-x1);
 calccircle(r);
 hline(x1+r-point[0],y1,sizex-(r-point[0])*2+1,currentcolor);
 vline(x1,y1+r,y2-y1-r*2,currentcolor);
 hline(x1+r-point[0],y2,sizex-(r-point[0])*2+1,currentcolor);
 vline(x2,y1+r,y2-y1-r*2,currentcolor);
 for y := 1 to r do
 for x := r-point[y] to r-point[y-1] do begin
   putpixel(x1+x,y1+y,currentcolor);
   putpixel(x2-x,y1+y,currentcolor);
 end;
 for y := 1 to r do
 for x := r-point[y] to r-point[y-1] do begin
   putpixel(x1+x,y2-y,currentcolor);
   putpixel(x2-x,y2-y,currentcolor);
 end;
end;

procedure hline(x1,y1,sizex: integer;col : byte);
{draw a horizontal line}
var
  i2,i3   : word;
  putmaxx : word;
  mxx     : word;
begin
 if sizex < 1 then exit;
 if (x1 < maxx)and(x1+sizex > 0)and(y1 >= 0)and((y1 <= viewport.mxy)or(not viewport.clip)) then begin
   inc(y1,pageadd);

   if x1 < 0 then begin
     putmaxx := sizex+x1;
     x1 := 0;
   end else begin
     if viewport.clip then mxx := viewport.mxx+1 else mxx := maxx;
     if x1+sizex > mxx then putmaxx := mxx-x1 else
     putmaxx := sizex;
     if (putmaxx = 0) then exit;
     if putmaxx > mxx+1 then putmaxx := mxx+1;
   end;

   i2 := calcbank(x1,y1);
   if i2 < i2+putmaxx then
   filldword(ptr(writeptr,i2)^,putmaxx,col)
   else begin
     i3 := 65535-pred(i2);
     filldword(ptr(writeptr,i2)^,i3,col);
     incbank;
     filldword(ptr(writeptr,0)^,putmaxx-i3,col);
   end;
 end;
end;

procedure vline(x1,y1,sizey: integer;col : byte);
{draw a vertical line}
var
  putmaxy : word;
  mxy     : word;
begin
 inc(y1,pageadd);

 if y1 < 0 then begin
   putmaxy := sizey+y1;
   y1 := 0;
 end else begin
   if viewport.clip then mxy := viewport.mxy+1 else mxy := maxy;
   if y1+sizey > mxy then putmaxy := mxy-y1 else putmaxy := sizey;
   if (putmaxy = 0) then exit;
   if viewport.clip then if putmaxy > mxy+1 then putmaxy := mxy+1;
 end;

 asm
  push x1
  push y1
  call calcbank
  mov  di,writeptr
  mov  es,di
  mov  di,ax
  mov  al,col
  mov  cx,putmaxy
  @lp:
    mov  es:[di],al
    add  di,bytesperscanline
    jnc  @next
      call incbank
    @next:
  dec  cx
  jnz  @lp
 end;
end;

procedure putline(x1,y1,sizex: integer;p : pointer);
{draw a horizontal line with image of the pointer p}
var
  i2,i3,putmaxx,mempos : word;
begin
 if sizex < 1 then exit;
 if (x1 < maxx)and(x1+sizex > 0)and(y1 >= 0)and((y1 < maxy)or(not viewport.clip)) then begin
   inc(y1,pageadd);
   mempos := 0;
   putmaxx := sizex;

   if x1 < 0 then begin
     putmaxx := sizex+x1;
     mempos := -x1;
     x1 := 0;
   end else begin
     if x1+sizex > maxx then putmaxx := maxx-x1 else
     putmaxx := sizex;
   end;

   if x1+putmaxx > maxx then putmaxx := maxx-x1;
   i2 := calcbank(x1,y1);
   if i2 < i2+putmaxx then
   {move2screen(ptr(seg(p^),ofs(p^)+mempos)^,ptr(writeptr,i2)^,putmaxx)}
   asm
    mov  ax,mempos
    mov  di,i2
    mov  cx,putmaxx
    mov  bx,writeptr
    mov  dx,ds
    lds  si,p
    add  si,ax
    mov  es,bx
    mov  ax,cx
    cmp  cx,8
    jb   @start
    mov  cx,di
    and  cx,11b
    jz   @iszero
    mov  bx,4
    sub  bx,cx
    mov  cx,bx
    rep  movsb
    sub  ax,bx
    @iszero:
    mov  cx,ax
    @start:
     shr  cx,2
     db   0F3h,66h,0A5h{rep movsd}
     mov  cx,ax
     and  cx,11b
     jz   @end
     rep  movsb
    @end:
    mov  ds,dx
   end
   else begin
     i3 := 65535-pred(i2);
     move2screen(ptr(seg(p^),ofs(p^)+mempos)^,ptr(writeptr,i2)^,i3);
     incbank;
     move2(ptr(seg(p^),ofs(p^)+i3+mempos)^,ptr(writeptr,0)^,putmaxx-i3);
   end;
 end;
end;

procedure getline(x1,y1,sizex: integer;p : pointer);
{get a horizontal line and puts the image to the pointer p}
var
  i2,i3,getmaxx : word;
begin
 if sizex < 1 then exit;
 if (x1 < maxx)and(x1+sizex > 0)and(y1 >= 0)and((y1 < maxy)or(not viewport.clip)) then begin
   inc(y1,pageadd);
   if x1 < 0 then begin
     getmaxx := sizex+x1;
     x1 := 0;
   end else begin
     if x1+sizex > maxx then getmaxx := maxx-x1 else
     getmaxx := sizex;
   end;
   i2 := calcbank(x1,y1);
   if i2 < i2+getmaxx then
   movefromscreen(ptr(writeptr,i2)^,p^,getmaxx)
   else begin
     i3 := 65535-pred(i2);
     movefromscreen(ptr(writeptr,i2)^,p^,i3);
     incbank;
     move2(ptr(writeptr,0)^,ptr(seg(p^),ofs(p^)+i3)^,getmaxx-i3);
   end;
 end;
end;


procedure outtextxy(x,y : integer;s : string);
{only for compatibility}
begin
 writexy(x,y,s);
end;

procedure settextstyle(font,direction,charsize: word);
{only for compatibility}
begin
 setfont(font,charsize);
end;

function getmaxx : word;assembler;
{only for compatibility}
asm
 mov  ax,mxx
end;

function getmaxy : word;assembler;
{only for compatibility}
asm
 mov  ax,mxy
end;

function getmaxcolor : word;assembler;
{only for compatibility}
asm
 mov  ax,255
end;

procedure setbank(bank : word);assembler;
{set the graphical bank of vesa}
asm
 push cx
 cmp  m,0
 je   @end
 mov  dx,bank
 cmp  dx,lastbank
 je   @end
 mov  lastbank,dx
 mov  cl,shifter
 shl  dx,cl
 xor  cl,cl
 xor  bx,bx
{$IFDEF DPMI}
 mov  ax,4F05h
 int  10h
{$ELSE}
 cmp  compmode,1
 je   @comp1
 call winfuncptr
 jmp  @normal1
 @comp1:
 mov  ax,4F05h
 int  10h
 @normal1:
{$ENDIF}
 mov  bl,twowins{for old GFX-cards... not tested yet}
 or   bl,bl
 jz   @end
 xor  bh,bh
{$IFDEF DPMI}
 mov  ax,4F05h
 int  10h
{$ELSE}
 cmp  compmode,1
 je   @comp2
 call winfuncptr
 jmp  @normal2
 @comp2:
 mov  ax,4F05h
 int  10h
 @normal2:
{$ENDIF}
 @end:
 pop cx
end;

function getbank : word;assembler;
{get the graphical bank of vesa}
asm
 push cx
 cmp m,0
 je @end
{$IFDEF DPMI}
 mov ax,4F05h
 xor bh,bh
 mov bl,01h
 int 10h
{$ELSE}
 mov bh,01h
 call winfuncptr
{$ENDIF}
 mov ax,dx
 mov lastbank,ax
 mov cl,shifter
 shr ax,cl
 @end:
 pop cx
end;

procedure decbank;assembler;
{decrease the graphical bank of vesa}
asm
 pusha
 cmp  m,0
 je   @end
 mov  dx,lastbank
 dec  dx
 mov  lastbank,dx
 mov  cl,shifter
 shl  dx,cl
 xor  cl,cl
 xor  bx,bx
{$IFDEF DPMI}
 mov  ax,4F05h
 int  10h
{$ELSE}
 cmp  compmode,1
 je   @comp1
 call winfuncptr
 jmp  @normal1
 @comp1:
 mov  ax,4F05h
 int  10h
 @normal1:
{$ENDIF}
 mov  bl,twowins{for old GFX-cards... not tested yet}
 or   bl,bl
 jz   @end
 xor  bh,bh
{$IFDEF DPMI}
 mov  ax,4F05h
 int  10h
{$ELSE}
 cmp  compmode,1
 je   @comp2
 call winfuncptr
 jmp  @normal2
 @comp2:
 mov  ax,4F05h
 int  10h
 @normal2:
{$ENDIF}
 @end:
 popa
end;

procedure incbank;assembler;
{increase the graphical bank of vesa}
asm
 pusha
 cmp  m,0
 je   @end
 mov  dx,lastbank
 inc  dx
 mov  lastbank,dx
 mov  cl,shifter
 shl  dx,cl
 xor  cl,cl
 xor  bx,bx
{$IFDEF DPMI}
 mov  ax,4F05h
 int  10h
{$ELSE}
 cmp  compmode,1
 je   @comp1
 call winfuncptr
 jmp  @normal1
 @comp1:
 mov  ax,4F05h
 int  10h
 @normal1:
{$ENDIF}
 mov  bl,twowins{for old GFX-cards... not tested yet}
 or   bl,bl
 jz   @end
 xor  bh,bh
{$IFDEF DPMI}
 mov  ax,4F05h
 int  10h
{$ELSE}
 cmp  compmode,1
 je   @comp2
 call winfuncptr
 jmp  @normal2
 @comp2:
 mov  ax,4F05h
 int  10h
 @normal2:
{$ENDIF}
 @end:
 popa
end;

{$F+}
procedure setbank2(bank : word);assembler;
{set the actual bank- don't look, if this bank is already setted}
asm
 push cx
 cmp  m,0
 je   @end
 mov  dx,bank
 mov  lastbank,dx
 mov  cl,shifter
 shl  dx,cl
 xor  cl,cl
 xor  bx,bx
{$IFDEF DPMI}
 mov  cl,shifter
 shl  dl,cl
 xor  cl,cl
 mov  ah,4Fh
 mov  al,05h
 int  10h
{$ELSE}
 cmp  compmode,1
 je   @comp1
 call winfuncptr
 jmp  @normal1
 @comp1:
 mov  ax,4F05h
 int  10h
 @normal1:
{$ENDIF}
 mov  bl,twowins{for old GFX-cards... not tested yet}
 or   bl,bl
 jz   @end
 xor  bh,bh
{$IFDEF DPMI}
 mov  ax,4F05h
 int  10h
{$ELSE}
 cmp  compmode,1
 je   @comp2
 call winfuncptr
 jmp  @normal2
 @comp2:
 mov  ax,4F05h
 int  10h
 @normal2:
{$ENDIF}
 @end:
 pop  cx
end;
{$F-}

procedure putpixel(x,y :word;color : byte);assembler;
asm
 db   66h;xor cx,cx
 mov  bx,x
 add  bx,viewport.x1
 mov  cx,bytesperscanline
 cmp  bx,cx
 jnb  @end
 mov  ax,y
 add  ax,pageadd
 add  ax,viewport.y1
 db   66h;mul cx
 mov  cx,bx
 db   66h;add ax,cx
 mov  si,ax
 db   66h;shr ax,16
 cmp  ax,lastbank
 je   @next
 push ax
 call setbank2
 @next:

 mov  ax,writeptr
 mov  es,ax
 mov  al,color
 mov  es:[si],al
@end:
end;

function getpixel(x,y :word) : byte;assembler;
asm
 mov  ax,pageadd
 add  y,ax
 db   66h;xor cx,cx
 mov  bx,x
 mov  cx,bytesperscanline
 cmp  bx,cx
 jnb  @end
 mov  ax,y
 add  ax,pageadd
 db   66h;mul cx
 mov  cx,bx
 db   66h;add ax,cx
 mov  si,ax
 db   66h;shr ax,16
 cmp  ax,lastbank
 je   @next
 push ax
 call setbank2
 @next:

 mov  ax,readptr
 mov  es,ax
 mov  al,es:[si]
@end:
end;

procedure waitretrace;assembler;
{waits until kathod-beam runs to the top of the screen - avoids flickering}
asm
 mov  dx,03DAh
 @lp1:
   in   al,dx
   test al,8
 jz   @lp1
 @lp2:
   in   al,dx
   test al,8
 jnz  @lp2
end;

procedure pageretrace;assembler;
{avoids flickering when using setvisualpage with S3-cards}
asm
 cmp s3,0
 je @end
 mov  dx,03DAh
 @lp1:
   in   al,dx
   test al,8
 jz   @lp1
 @lp2:
   in   al,dx
   test al,8
 jz  @lp2
@end:
end;

procedure hretrace;assembler;
{waits until kathod-beam is in next scanline}
asm
 mov dx,3DAh
 @lp1:
   in   al,dx
   test al,1D
 jnz  @lp1
 @lp2:
   in   al,dx
   test al,1D
 jz   @lp2
end;



procedure gettext;
{get and save the text screen}
begin
 if not getted then begin
   cpos.x := wherex;
   cpos.y := wherey;
   if lastmode = 3+font8x8 then load := 80*50*4 else load := 80*25*2;
   getmem(screen,load);
   move2(ptr(getrmselector($B800),0)^,screen^,load);
   getted := true;
 end;
end;

procedure settext;
{put the saved text screen}
begin
 if getted then begin
   if lastmode = 3+font8x8 then load := 80*50*4 else load := 80*25*2;
   move2(screen^,ptr(getrmselector($B800),0)^,load);
   gotoxy(cpos.x,cpos.y);
{  freemem(screen,load);}
   getted := false;
 end;
end;

procedure getimagesize(p : pointer;var x,y : word);assembler;
{gets the size of an image in memory}
asm
 mov  dx,ds
 les  di,p
 mov  ax,es:[di]
 mov  bx,es:[di+2]
 lds  si,x
 mov  ds:[si],ax
 lds  si,y
 mov  ds:[si],bx
 mov  ds,dx
end;

procedure setimagesize(p : pointer;x,y : word);assembler;
{sets the size of an image in memory}
asm
 les  di,p
 mov  ax,y
 db   66h;shl ax,16
 mov  ax,x
 db   66h;mov es:[di],ax
end;

function imagesize(x1,y1,x2,y2 : word) : word;
begin
imagesize := succ(abs(x2-x1))*succ(abs(y2-y1))+4;
end;

procedure setrgbpalette(i,r,g,b : byte);assembler;
{sets color i to rgb value}
asm
 mov  al,i
 mov  dx,03C8h
 out  dx,al
 mov  dx,03C9h
 mov  al,r
 out  dx,al
 mov  al,g
 out  dx,al
 mov  al,b
 out  dx,al
end;

procedure setpal;assembler;
{sets complete palette.. faaast}
asm
 xor bx,bx
 les di,pal

 mov cx,03C8h
 mov si,03C9h

@lp:   mov  al,bl
       mov  dx,cx
       out  dx,al
       mov  dx,si
db 66h;mov  ax,es:[di]
       out  dx,al

db 66h;shr  ax,8
       out  dx,al

db 66h;shr  ax,8
       out  dx,al

       add  di,3

   inc bx
   cmp bx,255
 jna @lp
end;


procedure shiftpal;
var
  i : integer;
begin
 for i := 0 to 255 do begin
   pal^[i].r := pal^[i].r shr 2;
   pal^[i].g := pal^[i].g shr 2;
   pal^[i].b := pal^[i].b shr 2;
 end;
end;


procedure setuserpal(var pal);assembler;
{sets the user-palette from pointer pal}
asm
 xor bx,bx
 les di,pal

 mov cx,03C8h
 mov si,03C9h

@lp:   mov   al,bl
       mov   dx,cx
       out   dx,al
       mov   dx,si
db 66h;mov   ax,es:[di]
       out   dx,al
db 66h;shr   ax,8
       out   dx,al
db 66h;shr   ax,8
       out   dx,al
       add   di,3
   inc bx
   cmp bx,255
 jna @lp
end;

procedure getrgbpalette (color : byte; var r, g, b : byte);
{not very optimized}
begin
 port [$3c7] := color;
 r := port [$3c9];
 g := port [$3c9];
 b := port [$3c9]
end;

procedure getpal;
{azo}
begin
 for i := 0 to 255 do begin
   Port[$3C7] := i;
   Pal^[i].r  := Port[$3C9];
   Pal^[i].g  := Port[$3C9];
   Pal^[i].b  := Port[$3C9];
 end;
end;

procedure getuserpal(var pal);
{gets the actual palette to pointer pal}
begin
 for i := 0 to 255 do begin
   Port[$3C7] := i;
   mem[seg(pal):ofs(pal)+i*3]  := Port[$3C9];
   mem[seg(pal):ofs(pal)+i*3+1]:= Port[$3C9];
   mem[seg(pal):ofs(pal)+i*3+2]:= Port[$3C9];
 end;
end;

procedure setrgbpal(i,r,g,b : byte);
{sets color i in virtual palette}
begin
 pal^[i].r := r;
 pal^[i].g := g;
 pal^[i].b := b;
end;

procedure getrgbpal(i : byte;var r,g,b : byte);
{sets color i in virtual palette}
begin
 r := pal^[i].r;
 g := pal^[i].g;
 b := pal^[i].b;
end;


procedure loadjascpal(path : string);
{loads JASC-Palettes made with Paint Shop Pro
 into virtual palette.. you have to call thereafter
 setpal if you want to set the palette}
var
  i2,setted  : byte   ;
  maxcol     : word   ;
  f          : text   ;
  s,s2       : string ;
  code,r,g,b : integer;
begin
 i := ioresult;
 assign(f,path);
 {$I-}
 reset(f);
 {$I+}
 if ioresult <> 0 then exit;
 readln(f,s);
 if s <> 'JASC-PAL' then exit;
 if eof(f) then begin
   close(f);
   exit;
 end;
 readln(f);
 if eof(f) then begin
   close(f);
   exit;
 end;
 readln(f,maxcol);
 dec(maxcol);
 if eof(f) then begin
   close(f);
   exit;
 end;
 s2 := '';
 for i := 0 to maxcol do begin
   readln(f,s);
   setted := 0;
   for i2 := 1 to length(s) do begin
     if s[i2] <> ' ' then s2 := s2+s[i2];
     if (s[i2] = ' ')or(i2 = length(s)) then begin
       case setted of
         0 : val(s2,r,code);
         1 : val(s2,g,code);
         2 : val(s2,b,code);
       end;
       inc(setted);
       s2 := '';
     end;
   end;
   pal^[i].r := r shr 2;
   pal^[i].g := g shr 2;
   pal^[i].b := b shr 2;
   if eof(f) then begin
     close(f);
     exit;
   end;
 end;
 close(f);
end;

procedure setcolor(col : byte);assembler;
{sets current color for script and lines}
asm
 xor  ah,ah
 mov  al,col
 mov  currentcolor,al
end;

function getcolor : byte;assembler;
{sets current color for script and lines}
asm
 mov al,currentcolor
end;


procedure setfillstyle(pattern: word; col: byte);
{sets current fillstyle}
begin
 fillcolor := col;
end;

procedure setfillcolor(col: byte);
{sets current fillstyle}
begin
 fillcolor := col;
end;


var
  writemode : byte;

procedure setwritemode(mode : byte);
begin
 writemode := mode;
end;

procedure line(x1,y1,x2,y2: integer);assembler;
{Complete description in C'T 2/97
 Listing in VESA8.ASM with full comments and little bit
 other form... I had to adjust something for my own unit..
 it's a little bit faster than it's original (Pentii-optimized) :>}
var
  w    : word;
asm
 mov  ax,pageadd
 add  ax,viewport.y1
 add  y1,ax
 add  y2,ax
 mov  ax,viewport.x1
 add  x1,ax
 add  x2,ax
		PUSH	BP
                MOV     SI,X2         { XE }
                SUB     SI,X1         { XE - X }
		JNS	@PutLine_2
		MOV	AX,X2
{		XCHG	AX,X1}{_very_ slow on a Pentii}
                MOV     BX,AX
                MOV     AX,X1
                MOV     X1,BX
		MOV	X2,AX
		MOV	AX,Y2
{		XCHG	AX,Y1}
                MOV     BX,AX
                MOV     AX,Y1
                MOV     Y1,BX
		MOV	Y2,AX
		NEG	SI		{ DLTX:= -DLTX }
@PutLine_2:
           PUSHA
    db 66h;XOR AX,AX
    db 66h;XOR DX,DX
           MOV AX,bytesperscanline
           MOV DX,Y1
    db 66h;MUL DX
           MOV DX,X1
    db 66h;ADD AX,DX
           MOV W,AX
    db 66h;SHR AX,16
           cmp ax,lastbank
           je @next
           PUSH AX
           CALL setbank2
           @next:
           POPA
           MOV DI,W
           MOV ES,writeptr

                MOV     AL,writemode
		CMP	AL,xorput
		JE	@PutLine_X
		MOV	AL,currentcolor	{ AL := Farbe }

		MOV	ES:[DI],AL
		MOV	BX,Y2
		SUB	BX,Y1
		JNS	@PutLine_8
		NEG	BX		{ DLTY := -DLTY }
                CMP     SI,BX
		JG	@PutLine_20
		MOV	CX,BX		{ Loopcount = DLTY }
                OR      CX,CX
		JZ	@PutLine_0	{ Loopcount = 0 ? }
                MOV     BP,BX
		NEG	BP		{ SUM = - DLTY }
		ADD	SI,SI		{ 2 * DLTX }
		ADD	BX,BX		{ 2 * DLTY }
@PutLine_12:    SUB	DI,bytesperscanline         { Y := Y - 1 }
		JC	@PutLine_13	{ Achte auf Bankswitch }
@PutLine_14:    ADD	BP,SI		{ SUM := SUM + 2 DLTX }
		JS	@PutLine_16	{ Skip, wenn SUM < 0 }
		SUB	BP,BX		{ SUM = SUM - 2 DLTY }
		INC	DI		{ X := X + 1 }
		JZ	@PutLine_15	{ Achte auf Bankswitch }
@PutLine_16:    MOV	ES:[DI],AL	{ Setze Pixel }
		DEC	CX
		JNZ	@PutLine_12	{ Loop mit DLTY }
		JMP	@PutLine_0
@PutLine_13:	CALL	DecBank
		JMP	@PutLine_14
@PutLine_15:	CALL	IncBank
		JMP	@PutLine_16
@PutLine_20:	MOV	CX,SI		{ Loopcount = DLTX }
		JCXZ	@PutLine_0	{ Loopcount = 0 ? }
		MOV	BP,SI
		NEG	BP		{ SUM = - DLTX }
		ADD	SI,SI		{ 2 * DLTX }
		ADD	BX,BX		{ 2 * DLTY }
@PutLine_22:    INC	DI			{ X := X + 1 }
		JZ	@PutLine_23	        { Achte auf Bankswitch }
@PutLine_24:    ADD	BP,BX			{ SUM := SUM + 2 DLTY }
		JS	@PutLine_26	        { Skip, wenn SUM < 0 }
		SUB	BP,SI			{ SUM := SUM - 2DLTX }
		SUB	DI,bytesperscanline         	{ Y := Y - 1 }
		JC	@PutLine_25	        { Achte auf Bankswitch }
@PutLine_26:    MOV	ES:[DI],AL		{ Setze Pixel }
		DEC	CX
		JNZ	@PutLine_22	        { Loop mit DLTX }
@PutLine_0:     POP	BP
                JMP     @END
@PutLine_23:	CALL	IncBank
		JMP	@PutLine_24
@PutLine_25:	CALL	DecBank
		JMP	@PutLine_26
@PutLine_8:	CMP	SI,BX
		JG	@PutLine_40
		MOV	CX,BX		{ Loopcount = DLTY }
		JCXZ	@PutLine_0	{ Loopcount = 0 ? }
		MOV	BP,BX
		NEG	BP		{ SUM = - DLTY }
		ADD	SI,SI		{ 2 * DLTX }
		ADD	BX,BX		{ 2 * DLTY }
@PutLine_32:    ADD	DI,bytesperscanline         { Y := Y + 1 }
		JC	@PutLine_33	        { Achte auf Bankswitch }
@PutLine_34:    ADD	BP,SI			{ SUM := SUM + 2 DLTX }
		JS	@PutLine_36	        { Skip, wenn SUM < 0 }
		SUB	BP,BX			{ SUM := SUM - 2 DLTY }
		INC	DI			{ X := X + 1 }
		JZ	@PutLine_35	        { Achte auf Bankswitch }
@PutLine_36:    MOV	ES:[DI],AL		{ Setze Pixel }
		DEC	CX
		JNZ	@PutLine_32	        { Loop mit DLTY }
		JMP	@PutLine_0
@PutLine_33:	CALL	IncBank
		JMP	@PutLine_34
@PutLine_35:	CALL	IncBank
		JMP	@PutLine_36
@PutLine_40:	MOV	CX,SI		{ Loopcount = DLTX }
		JCXZ	@PutLine_0	{ Loopcount = 0 ? }
		MOV	BP,SI
		NEG	BP		{ SUM = - DLTX }
		ADD	SI,SI		{ 2 * DLTX }
		ADD	BX,BX		{ 2 * DLTY }
@PutLine_42:    INC	DI			{ X := X + 1 }
		JZ	@PutLine_43	        { Achte auf Bankswitch }
@PutLine_44:    ADD	BP,BX			{ SUM := SUM + 2 DLTY }
		JS	@PutLine_46	        { Skip, wenn SUM < 0 }
		SUB	BP,SI			{ SUM := SUM - 2 DLTX }
		ADD	DI,bytesperscanline                 { Y := Y + 1 }
		JC	@PutLine_45	        { Achte auf Bankswitch }
@PutLine_46:    MOV	ES:[DI],AL		{ Setze Pixel }
		DEC	CX
		JNZ	@PutLine_42	        { Loop mit DLTX }
		JMP	@PutLine_0
@PutLine_43:	CALL	IncBank
		JMP	@PutLine_44
@PutLine_45:	CALL	IncBank
		JMP	@PutLine_46
@PutLine_X:     MOV     AL,currentcolor	{ AL := Farbe }
                XOR	ES:[DI],AL
                MOV     BX,Y2
		SUB	BX,Y1
		JNS	@PutLinX_8
		NEG	BX		{ DLTY := -DLTY }
                CMP     SI,BX
		JG	@PutLinX_20
		MOV	CX,BX		{ Loopcount = DLTY }
		JCXZ	@PutLinX_0	{ Loopcount = 0 ? }
                MOV     BP,BX
		NEG	BP		{ SUM = - DLTY }
		ADD	SI,SI		{ 2 * DLTX }
		ADD	BX,BX		{ 2 * DLTY }
@PutLinX_12:    SUB	DI,bytesperscanline         { Y := Y - 1 }
		JC	@PutLinX_13	        { Achte auf Bankswitch }
@PutLinX_14:    ADD	BP,SI			{ SUM := SUM + 2 DLTX }
		JS	@PutLinX_16	        { Skip, wenn SUM < 0 }
		SUB	BP,BX			{ SUM = SUM - 2 DLTY }
		INC	DI			{ X := X + 1 }
		JZ	@PutLinX_15	        { Achte auf Bankswitch }
@PutLinX_16:    XOR	ES:[DI],AL		{ Setze Pixel }
		DEC	CX
		JNZ	@PutLinX_12	        { Loop mit DLTY }
		JMP	@PutLinX_0
@PutLinX_13:	CALL	DecBank
		JMP	@PutLinX_14
@PutLinX_15:	CALL	IncBank
		JMP	@PutLinX_16
@PutLinX_20:	MOV	CX,SI		{ Loopcount = DLTX }
		JCXZ	@PutLinX_0	{ Loopcount = 0 ? }
                MOV     BP,SI
		NEG	BP		{ SUM = - DLTX }
		ADD	SI,SI		{ 2 * DLTX }
		ADD	BX,BX		{ 2 * DLTY }
@PutLinX_22:    INC	DI			{ X := X + 1 }
		JZ	@PutLinX_23	        { Achte auf Bankswitch }
@PutLinX_24:    ADD	BP,BX			{ SUM := SUM + 2 DLTY }
		JS	@PutLinX_26	        { Skip, wenn SUM < 0 }
		SUB	BP,SI			{ SUM := SUM - 2DLTX }
		SUB	DI,bytesperscanline                 { Y := Y - 1 }
		JC	@PutLinX_25	        { Achte auf Bankswitch }
@PutLinX_26:    XOR	ES:[DI],AL		{ Setze Pixel }
		DEC	CX
		JNZ	@PutLinX_22	        { Loop mit DLTX }
@PutLinX_0:     JMP	@PutLine_0
@PutLinX_23:	CALL	IncBank
		JMP	@PutLinX_24
@PutLinX_25:	CALL	DecBank
		JMP	@PutLinX_26
@PutLinX_8:	CMP	SI,BX
		JG	@PutLinX_40
		MOV	CX,BX		{ Loopcount = DLTY }
		JCXZ	@PutLinX_0	{ Loopcount = 0 ? }
                MOV     BP,BX
		NEG	BP		{ SUM = - DLTY }
		ADD	SI,SI		{ 2 * DLTX }
		ADD	BX,BX		{ 2 * DLTY }
@PutLinX_32:    ADD	DI,bytesperscanline         { Y := Y + 1 }
		JC	@PutLinX_33	{ Achte auf Bankswitch }
@PutLinX_34:    ADD	BP,SI			{ SUM := SUM + 2 DLTX }
		JS	@PutLinX_36	        { Skip, wenn SUM < 0 }
		SUB	BP,BX			{ SUM := SUM - 2 DLTY }
		INC	DI			{ X := X + 1 }
		JZ	@PutLinX_35	        { Achte auf Bankswitch }
@PutLinX_36:    XOR	ES:[DI],AL		{ Setze Pixel}
		DEC	CX
		JNZ	@PutLinX_32	        { Loop mit DLTY}
		JMP	@PutLinX_0
@PutLinX_33:	CALL	IncBank
		JMP	@PutLinX_34
@PutLinX_35:	CALL	IncBank
		JMP	@PutLinX_36
@PutLinX_40:	MOV	CX,SI		{ Loopcount = DLTX}
		JCXZ	@PutLinX_0	{ Loopcount = 0 ?}
                MOV     BP,SI
		NEG	BP		{ SUM = - DLTX}
		ADD	SI,SI		{ 2 * DLTX }
		ADD	BX,BX		{ 2 * DLTY }
@PutLinX_42:    INC	DI			{ X := X + 1}
		JZ	@PutLinX_43	        { Achte auf Bankswitch}
@PutLinX_44:    ADD	BP,BX			{ SUM := SUM + 2 DLTY}
		JS	@PutLinX_46	        { Skip, wenn SUM < 0}
		SUB	BP,SI			{ SUM := SUM - 2 DLTX}
		ADD	DI,bytesperscanline                 { Y := Y + 1}
		JC	@PutLinX_45	        { Achte auf Bankswitch}
@PutLinX_46:    XOR	ES:[DI],AL		{ Setze Pixel}
		DEC	CX
		JNZ	@PutLinX_42	        { Loop mit DLTX}
		JMP	@PutLinX_0
@PutLinX_43:	CALL	IncBank
		JMP	@PutLinX_44
@PutLinX_45:	CALL	IncBank
		JMP	@PutLinX_46
@end:
end;

procedure rectangle(x1,y1,x2,y2: integer);
begin
 line(x1,y1,x2,y1);
 line(x1,y1,x1,y2);
 line(x2,y1,x2,y2);
 line(x1,y2,x2,y2);
end;

function getclock: longInt;assembler; {Taken from the FLILIB source}
asm
 xor  ah,ah           { get tick count from Dos and use For hi 3 Bytes }
 int  01Ah            { lo order count in DX, hi order in CX }
 mov  ah,dl
 mov  dl,dh
 mov  dh,cl
 xor  al,al           { read lo Byte straight from timer chip }
 out  43h,al          { latch count }

 mov  al,1
 out  43h,al          { set up to read count }
 in   al,40h          { read in lo Byte (and discard) }
 in   al,40h          { hi Byte into al }
 neg  al              { make it so counting up instead of down }
end;


procedure readgraphline(x1,y1,col,maxchars,posx : word;var s2 : string);
{read a line (like readln) from graphical screen
x1,y1    : position
col      : color of the text
maxchars : maximum amount of chars to read
posx     : position (cursor) in the text should be =>1
s2       : string where to read in (can be prefilled)}
var
  txt                : char;
  waittime           : longint;
  chars,i,y,width    : integer;
  ch,lch             : char;
  s                  : string[80];
  p                  : pointer;
  con                : boolean;

procedure delete2(var s : string;chpos,num : byte);
begin
  system.delete(s,chpos,num);
  insert(' ',s,80);
end;

function txtpos : word;
var
  s2 : string ;
  i  : integer;
begin
 s2 := '';
 for i := 1 to posx-1 do s2 := s2 + s[i];
 txtpos := textwidth(s2);
end;

procedure showtxt;
begin
 putimage(x1,y1,p);
 writexy(x1,y1,s);
 line(txtpos+x1,y1+1,txtpos+x1,textheight+y1);
 con := true;
end;


begin
 setcolor(col);
 chars := length(s2);
 s := s2;
 for i := 0 to 80-length(s2) do s := s + ' ';
 filldword(s2[1],maxchars,ord('T'));
 s2[0] := chr(maxchars);
 width := textwidth(s2);
 getmem(p,imagesize(0,0,width,textheight));
 getimage(x1,y1,width+x1,textheight+y1,p);
 filldword(s2[0],80,0);
 lch := #1;
 showtxt;
 waittime := getclock+ 1250;
 repeat
   if waittime <= getclock then begin
     if con then begin
       for y := 1 to textheight do
       putpixel(txtpos+x1,y1+y,mem[seg(p^):ofs(p^)+4+succ(width)*y+txtpos]);
     end else
     line(txtpos+x1,y1+1,txtpos+x1,textheight+y1);
     con := not con;
     waittime := getclock+ 1250;
   end;
   if keypressed then begin
     lch := ch;
     ch := readkey
   end else ch := #1;

   if (ord(ch)> 1)and(lch <> #0) then
   case ch of
     #8  : if posx > 1 then begin dec(chars);dec(posx);delete2(s,posx,1);showtxt;end;
 #13,#27 : begin;for i := 1 to chars do s2 := s2 + s[i];end;
    else if chars < maxchars then begin
      inc(chars);inc(posx); insert(ch,s,posx-1);
      showtxt;
      end;
   end;
   if (ch <> #1)and(lch = #0) then begin
     case ch of
       #71 : begin posx := 1;showtxt;end;
       #79 : begin posx := chars+1;showtxt;end;
       #75 : if posx > 1 then begin;dec(posx);showtxt;end;
       #77 : if posx <= chars then begin;inc(posx);showtxt;end;
       #83 :
if posx <= chars then begin dec(chars);delete2(s,posx,1);showtxt;end;
      else lch := #1;
     end;
   end;

 until (ch = #27)or(ch = #13);
 if con then begin
   for y := 1 to textheight do
   putpixel(txtpos+x1,y1+y,mem[seg(p^):ofs(p^)+4+succ(width)*y+txtpos]);
 end;
 freemem(p,imagesize(0,0,textwidth(s),textheight));
 setwritemode(normalput);
end;


function findnearcol(nr,ng,nb : byte) : byte;assembler;
{searches for nearest color in virtal palette- don't
 worx at all coz it uses the sum of the values.. but fast}
asm
 mov  al,nr
 add  al,ng
 add  al,nb
 or   al,al
 jz   @stop
 mov  dl,255
 mov  si,1024
 les  di,graphics.pal
 add  di,768
 xor  ch,ch
 @lp:
   xor  bh,bh
   dec  di
   mov  al,es:[di]
   mov  bl,nb
   sub  bl,al
   dec  di
   mov  al,es:[di]
   mov  cl,ng
   sub  cl,al
   add  bx,cx
   dec  di
   mov  al,es:[di]
   mov  cl,nr
   sub  cl,al
   add  bx,cx
   cmp  bx,si
   jnb  @end
   mov  si,bx
   mov  dh,dl
   @end:
 dec  dl
 jnz  @lp
 mov  al,dh
@stop:
end;


procedure getvesamodeinfo;
var
  i : word;
begin
 if m < 7 then i := modeset[m].mode
 else i := m;
{$IFDEF DPMI}
 asm
  cmp m,0
  je @end
  PUSH 0
  PUSH 256
  CALL GlobalDosAlloc
  MOV  Segment,DX
  MOV  Selector,AX

  mov  cx,i
  mov  DI,OFFSET RealModeRegs
  mov  WORD PTR [DI].TRealRegs.RealSP,0
  mov  WORD PTR [DI].TRealRegs.RealSS,0
  mov  WORD PTR [DI].TRealRegs.RealEAX,4F01h
  mov  WORD PTR [DI].TRealRegs.RealECX,CX
  mov  WORD PTR [DI].TRealRegs.RealES, DX
  mov  WORD PTR [DI].TRealRegs.RealEDI, 0
  mov  AX,DS
  mov  ES,AX
  mov  AX,0300h
  mov  BX,0010h
  int  31h
 @end:
 end;
 move2(ptr(selector,0)^,modeinfoblock,256);
 globaldosfree(selector);
{$ELSE}
 asm
  cmp  m,0
  je   @end
  mov  ax,4f01h
  mov  cx,i
  mov  di,seg modeinfoblock
  mov  es,di
  mov  di,offset modeinfoblock
  int  10h
 @end:
 end;
{$ENDIF}
 with vesainfoblock do begin
   if VESASignature <> 'VESA' then begin
     writeln('No VESA-extension found!!!');
     halt(2);
   end;
 end;
 winfuncptr := modeinfoblock.winfuncptr;
 bytesperscanline := modeinfoblock.bytesperscanline;
 bitsperpixel := modeinfoblock.bitsperpixel;
 lastbank := 255;
 if m < 7 then begin
   mxx := modeset[m].sx;
   mxy := modeset[m].sy;
   maxx := succ(mxx);
   maxy := succ(mxy);
 end else begin
   mxx := modeinfoblock.xresolution-1;
   mxy := modeinfoblock.yresolution-1;
   maxx := modeinfoblock.xresolution;
   maxy := modeinfoblock.yresolution;
 end;
 numofpages := ((longint(vesainfoblock.totalmemory) shl 16) div bytesperscanline) div maxy;
 if (hi(vesainfoblock.vesaversion) = 1)and(lo(vesainfoblock.vesaversion) = 0)
 then numofpages := 0;
 shifter := 7;
 i := modeinfoblock.WinGranularity;
 repeat
  i := i shr 1;
  dec(shifter)
 until i = 0;
end;


function getbit(value,bit : byte) : boolean;assembler;
asm
 mov cl,bit
 mov bl,1
 shl bl,cl
 mov al,value
 and al,bl
end;

procedure setscreen(on : boolean);
begin
 port[$3c4] := 1;
 if on then
 port[$3c5] := port[$3c5] and not 32 else
 port[$3c5] := port[$3c5] or 32;
end;


function initvesamode(mode : word) : boolean;assembler;
asm
 mov ah,4Fh
 mov al,02h
 mov bx,mode
 int 10h
 mov al,1
 cmp ah,4Fh
 je @next
 xor ah,ah
 @next:
end;

procedure initvgamode(mode : word);assembler;
asm
 mov ax,mode
 int 10h
end;

function GetRMSelector(segment : word) : word;assembler;
asm
{$ifdef dpmi}
 mov ax,$0002
 mov bx,segment
 int $31
{$else}
 mov ax,segment
{$endif}
end;

procedure set256mode(mode : integer);
begin
 m := mode;
 gettext;
 if mode > 0 then begin
   if not initvesamode(modeset[m].mode) then begin
     writeln('Error: VESA not initializeable');
     halt(2);
   end;
 end else initvgamode(modeset[m].mode);
 if speedupws then changews;
 {Speedup for Cirrus Logic 542x.. changes waitstates...}
 {tested it on Cirrus card: hangs- so be careful       }
 if m > 0 then begin
   getvesamodeinfo;
   s3 := s3detect;
   move(ptr(getrmselector(
   (longint(vesainfoblock.oemstringptr) shr 16)),
   (longint(vesainfoblock.oemstringptr) and $FFFF))^,s[1],255);

   if (S3)and(speedupS3) then begin
  {If S3-card is present, use speedup}
     if (pos('VESA VBE',s) = 0) then MAP_A000h;
{This shitty Univesa can't work with this speedup..
 so I have to detect it.. grmbl}
     FAST_WRITE_BUFFER_ON;
   end;
   if getbit(modeinfoblock.winBAttributes,2) then writeptr := getrmselector(modeinfoblock.winBsegment);
   if getbit(modeinfoblock.winAAttributes,2) then writeptr := getrmselector(modeinfoblock.winAsegment);

   if getbit(modeinfoblock.winBAttributes,1) then readptr := getrmselector(modeinfoblock.winBsegment);
   if getbit(modeinfoblock.winAAttributes,1) then readptr := getrmselector(modeinfoblock.winAsegment);
   {hope, it'll run coz not tested with two windows yet...}
 end else begin
  numofpages := 0;
  mxx := modeset[m].sx;
  mxy := modeset[m].sy;
  maxx := succ(mxx);
  maxy := succ(mxy);
  bytesperscanline := maxx;
  readptr := getrmselector($A000);
  writeptr:= readptr;
 end;
 pageadd := 0;
 if writeptr <> readptr then twowins := true else twowins := false;
 cleardevice;
 gfx_inited := true;
 setviewport(0,0,mxx,mxy,true);
 if winfuncptr = nil then compmode := true else compmode := false;
end;

procedure setviewport(x1,y1,x2,y2 : integer;clip : boolean);
begin
 viewport.x1  := x1;
 viewport.y1  := y1;
 viewport.x2  := x2;
 viewport.y2  := y2;
 viewport.clip:= clip;
 viewport.mxx := x2-x1;
 viewport.mxy := y2-y1;
end;

procedure getviewsettings(var viewport : viewporttype);
begin
 move2(graphics.viewport,viewport,sizeof(viewport));
end;

procedure clearviewport;
begin
 oldcol    := fillcolor;
 fillcolor := black;
 with viewport do bar(0,0,mxx,mxy);
 fillcolor := oldcol;
end;

function getmaxmode : integer;
begin
 getmaxmode := 4;{will be changed soon}
end;

procedure closegraph;assembler;
asm
 cmp gfx_inited,0
 je @end
 push lastmode
 call textmode
 call settext
 mov gfx_inited,0
@end:
end;


procedure sysfont2;external;
{$L SYSFONT2}
procedure littn2;external;
{$L LITTN2}
(*procedure atrax;external;
{-$L ATRAX}*)
(*procedure SYS16X16;external;
{-$L SYS16X16}*)

function loadfont(name : string;num : byte) : boolean;
{load font from hard disk}
var
  f       : file;
  i       : word;
  size    : byte;
  memsize : word;
begin
 loadfont := false;
 {$I-}
 assign(f,name);
 reset(f,1);
 {$I+}
 if ioresult <> 0 then exit;
 blockread(f,header[num],sizeof(header[num]));
 if header[num].kennung = 'GSCharset>>' then begin
   if header[num].chartype = 1 then
   for i := header[num].startchar to header[num].endchar do begin
   {if eof(f) then begin;close(f);exit;end;}
     blockread(f,size,1);
     charpoints[i].numofpoints := size;
     blockread(f,charpoints[i].pointpos,size*4);
   end else if header[num].chartype = 2 then begin
     memsize:=(header[num].width*header[num].height*header[num].colordepth)div 8*(header[num].endchar-header[num].startchar+1);
     getmem(chars[num],memsize);
     blockread(f,chars[num]^,memsize);{muss noch veraendert werden, um variabel zu sein}
   end else if header[num].chartype = 3 then begin
     memsize:= header[num].memsize;
     getmem(chars[num],memsize);
     blockread(f,chars[num]^,memsize);
   end;
 end else begin
   close(f);
   exit;
 end;
 close(f);
 loadfont := true;
end;


function loadfontmem(p : pointer;num : byte) : boolean;
{load font from memory}
var
  i    : word;
  size : byte;
  ppos : word;
  memsize : word;
begin
 ppos := 0;
 loadfontmem := false;
 move2(p^,header[num],sizeof(header[num]));
 inc(ppos,sizeof(header[num]));
 if header[num].kennung = 'GSCharset>>' then begin
   if header[num].chartype = 1 then
   for i := header[num].startchar to header[num].endchar do begin
     move(ptr(seg(p^),ofs(p^)+ppos)^,size,1);
     inc(ppos);
     charpoints[i].numofpoints := size;
     move2(ptr(seg(p^),ofs(p^)+ppos)^,charpoints[i].pointpos,size*4);
     inc(ppos,size*4);
   end else if header[num].chartype = 2 then
   chars[num] := ptr(seg(p^),ofs(p^)+ppos)
   else if header[num].chartype = 3 then
   chars[num] := ptr(seg(p^),ofs(p^)+ppos);
 end else exit;
 loadfontmem := true;
end;

procedure setfont(fnt,size : byte);
{set actual font}
begin
 font := fnt;
 currentsize := size;
end;

function textheight : word;
var
  i2,sy,chw,cy,cr : byte;
  crs,height      : byte;
  dummy,i         : word;
  incer           : word;
begin
 if header[font].chartype = 1 then begin
   crs := header[font].charsize;
   cr  := ord('T');
   height := 0;

   for i2 := 0 to charpoints[cr].numofpoints do with charpoints[cr] do begin
     cy := pointpos[i2].y*currentsize div crs;
     if height < cy then height := cy;
   end;
   textheight := height;
 end else textheight := header[font].height;
end;


procedure floodfill(x,y:integer; border:byte);
{not made by me, but it seems to run}
var
  offset        : longint;

procedure fill(x,y:integer);
var
  start,ende,xx : integer;
  col           : longint;

begin
 xx:=x; col:=getpixel(xx,y);
 if col=border then exit;
 while (col <> border) and (xx > 0) and (col <> fillcolor)
 do begin
   xx:=xx-1; col:=getpixel(xx,y);
 end;
 start:=xx+1;

 xx:=x+1; col:=getpixel(xx,y);
 while (col <> border) and (xx < maxx) and (col <> fillcolor)
 do begin
   xx:=xx+1; col:=getpixel(xx,y);
 end;
 ende:=xx-1;

 hline(start,ende,y,fillcolor);
 offset:=(y * maxy + start) shr 8;

 if (y > 0) then begin
   xx:=start;
   repeat
     col:=getpixel(xx,y-1);
     if (col <> border) and (col <> fillcolor)
     then begin
       fill(xx,y-1);
       {break;}
       xx := ende+1;
     end;
     xx:=xx+1;
   until xx > ende;
 end;

 if (y > 0) then begin
   xx:=start;
   repeat
     col:=getpixel(xx,y+1);
     if (col<>border) and (col<>fillcolor) then fill(xx,y+1);
     xx:=xx+1;
   until xx > ende;
 end;
end;

var
  buffermem : pointer;

begin
 getmem(buffermem,maxx);
 filldword(buffermem^,maxx,0);
 fill(x,y);
 freemem(buffermem,maxx);
end;


function textwidth(s : string) : word;
var
  i2,cr,sy,chw,cx : byte;
  crs,width    : byte;
  dummy,i      : word;
  xwidth       : word;
  incx         : word;
  incer,px     : word;
  chp          : pointer;
  dist         : byte;
begin
 if length(s) = 0 then begin
   textwidth := 0;
   exit;
 end;
 if header[font].chartype = 1 then begin
   xwidth := 0;
   crs    := header[font].charsize;
   incx   := (crs*currentsize) div 12;

   for i := 0 to pred(ord(s[0])) do begin
     cr := ord(s[i+1]);
     width := 0;
     if cr <> 32 then begin
       for i2 := 1 to charpoints[cr].numofpoints do with charpoints[cr] do
       begin
         cx := pointpos[i2].x;
         if (cr >= ord('0'))and((cr <= ord('9'))) then width := 12;
         if width < cx then width := cx;
       end;
     end else width := (crs*currentsize) div 7;
     asm
      mov  bl,crs
      mov  al,width
      mul  currentsize
      div  bl
      xor  ah,ah
      mov  bx,xwidth
      add  bx,ax
      add  bx,incx
      mov  xwidth,bx
     end;
   end;
   textwidth := xwidth;
 end else if header[font].chartype = 2 then
 textwidth := (header[font].width+header[font].distance)*length(s)
 else if header[font].chartype = 3 then begin
   xwidth := 0;
   chp    := chars[font];
   dist   := header[font].distance;

   for i := 0 to pred(ord(s[0])) do begin
     cr := ord(s[i+1]);
     px := memw[seg(chp^):ofs(chp^)+(cr-header[font].startchar)*2]+
     (header[font].endchar-header[font].startchar+1)*2;
     width := memw[seg(chp^):ofs(chp^)+px+2];
     if (cr <> 32)and(width > 0)and(cr >= header[font].startchar)
     and(cr <= header[font].endchar) then
     inc(xwidth,width+dist)
     else
     inc(xwidth,header[font].width);
   end;
   textwidth := xwidth;
 end;
end;


function makestr(w : longint) : String;
{convert integer to string}
var
  c : string;
begin
 str(w,c);
 makestr := c;
end;

function makestrr(r : real;sh,st : byte) : String;
{convert real to string}
var
  c : string;
begin
  str(r:sh:st,c);
  makestrr := c;
end;

procedure settextjustify(Horiz, Vert: Word);
begin
 textx := horiz;
 texty := vert;
end;

procedure writexy(x,y : integer;s : string);
var
  i2,cr,sy,chw,cx,chh : byte;
  crs,width,dist      : byte;
  dummy,i,i3          : word;
  xwidth              : word;
  px,py,lx,ly         : word;
  incx                : word;
  incer               : word;
  chp                 : pointer;
begin
 case textx of
   centertext : x := x-textwidth(s) div 2;
   righttext  : x := x-textwidth(s);
 end;
 case texty of
   centertext : y := y-textheight div 2;
   buttomtext : y := y-textheight;
 end;
 if length(s) = 0 then exit;
 if header[font].chartype = 1 then begin
   xwidth := x;
   crs    := header[font].charsize;
   incx   := (crs*currentsize) div 12;
   for i := 0 to pred(ord(s[0])) do begin
     cr := ord(s[i+1]);
     width := 0;
     if xwidth > viewport.mxx then break;
     if cr <> 32 then begin
       lx := charpoints[cr].pointpos[0].x*currentsize div crs+xwidth;
       ly := charpoints[cr].pointpos[0].y*currentsize div crs+y;
       asm
         mov di,seg charpoints
         mov es,di

         mov cx,65            { one vec-char : 65 bytes                }
         mov ax,word ptr cr   { get the char to draw                   }
         xor ah,ah
         mul cx               { and calculate memory position          }
         mov di,offset charpoints
         add di,ax
         mov al,es:[di]       { get the amount of lines to draw        }
         dec al
         mov i2,al            { and save it in i2                      }
         mov i3,0             { now reset i3                           }
         @drawlp:

           push di            { save di for next loop                  }
           mov dx,i3          { load i3                                }
           add dx,4           { increment it by 4,                     }
           mov i3,dx          { write the value back                   }
           {xor dh,dh}
           lea ax,es:[di+1]
           add ax,dx          { add now i3 to ax                       }
           mov di,ax          { now we have the actual memory position }
           mov bx,es:[di]     { so load x and y value to bx            }

           mov dl,currentsize { load current charsize                  }
           xor dh,dh
           xor ch,ch
           mov cl,crs         { load relative charsize of the font     }
           xor ah,ah          { we don't need ah any more              }
           mov al,bl          { move x value to al                     }
           mul dx             { and multiply with the charsize         }
           div cx             { now divide it by the relative charsize }
           mov si,ax
           add si,xwidth      { add the x-screenpos. to the point      }

           mov dl,currentsize { load current size again for multiply   }
           mov al,bh          { load the y-position to al              }
           mul dx             { and multiply it with the charsize      }
           div cx             { and divide it by the relative charsize }
           add ax,y           { and add y-screenposition               }


           cmp bl,width       { is the actual line wider than the      }
           jna @na            { last line? If yes: save new width      }
             mov width,bl
           @na:

           mov cx,lx          { save last point-positions for the next }
           mov dx,ly          { line-drawing                           }
           mov lx,si          { ...and save new values in it           }
           mov ly,ax
           mov bl,es:[di-2]   { should the next line be drawed? If no: }
           or bl,bl           { overjump line-drawing                  }
           jnz @end
           push es            { save es because of the pointer to the  }
                              { font                                   }
           push cx            { push all points for line               }
           push dx
           push si
           push ax
           call line          { ...and draw the line                   }

           pop es             { restore es                             }
           @end:
         pop di
         dec i2               { decrease number of lines to write      }
         jnz  @drawlp
       end;
     end else width := (crs*currentsize) div 7;
     asm
       mov bl,crs
       mov al,width
       mul currentsize
       div bl
       xor ah,ah
       mov bx,xwidth
       add bx,ax
       add bx,incx
       mov xwidth,bx
     end;
   end;
 end
 else if header[font].colordepth = 1 then begin
   if ((y < viewport.mxy+1) or (not viewport.clip)) and (x < viewport.mxx+1) and (y >= 0) then begin
     chw := header[font].width;
     chh := header[font].height;
     chp := chars[font];
     dist:= header[font].distance;
     sy  := header[font].height;
     if (sy+y > viewport.mxy) and (viewport.clip) then sy := (viewport.mxy+1)-y;
     inc(y,pageadd);
     if (x+ord(s[0])*(chw+dist)) > viewport.mxx+1 then
     s[0] := chr(((viewport.mxx+1)-x) div (chw+dist));

     if x < 0 then begin
       i := (x+ord(s[0])*(chw+dist));
       if i > 32767 then exit;
       x := i mod (chw+dist);
       i := i div (chw+dist);
       move2(s[length(s)-i+1],s[1],i);
       s[0] := chr(i);
     end;
     inc(x,viewport.x1);
     inc(y,viewport.y1);
     xwidth := x;
     incer := bytesperscanline-header[font].width;
     asm
{Mit diesem Algorythmus ist die Maximalgeschwindigkeit so gut
 wie ausgereizt. Optimierungen sind kaum noch moeglich. Alles
 Vorhandene ist _maximal_ optimiert. Einzige machbare Moeglich-
 keit: zwei Pixel nebeneinander als Word zu bewegen. Ist aller-
 dings mit erheblichem Aufwand verbunden. Pentium-optimiert.
 Fehlerprfung fr unten, rechts und links eingebaut. Keine
 Skalierung moeglich!}
      mov ax,writeptr
      mov es,ax                 { load into es the screenpointer    }

      mov i,0                   { begin with char 0                 }
      @lp3:
        mov py,0                { reset y-position                  }

        mov si,i                { load stringposition               }
        db 66h;xor cx,cx
        mov cl,chh
        mov ax,word ptr s[si+1] { load char from position+1         }
        xor ah,ah
        mul cx                  { ...and calculate it's memposition }
        mov di,ax               { now save this in di               }

        mov cx,bytesperscanline { calculate position in gxf-memory  }
        mov ax,y
        db 66h;mul cx
        mov cx,xwidth
      { cmp bx,cx
        jnb @end}
        db 66h;add ax,cx
        mov si,ax               { and save the lower 16bit in si    }

        db 66h;shr ax,16
        cmp ax,lastbank         { actual bank = setted bank?        }
        je @next                { if yes, goto next                 }
        push ax
        call setbank2           { if no, switch to new bank         }
        @next:

        mov al,currentcolor     { save drawcolor in al              }
        xor dh,dh
        mov dl,chw              { save charwidth in dl              }
        mov bx,xwidth           { and load actual x-position        }
        add bx,dx
        mov cx,maxx             { is char over maxx?                }
        cmp bx,cx
        jna @na
         sub bx,cx
         mov dl,bl
        @na:
        mov dh,sy               { load charheight in dh             }

        push ds
        lds bx,chp
        add di,bx
        @lp2:
          mov cl,dl             { X-Position auf Ausgangspunkt}
          mov ch,1              { Byteposition auf Ausgangspunkt}
          mov bl,ds:[di]        { neue Zeichenzeile laden...}
          inc di                { und nchste Zeile anvisieren}
          @lp:
            test bl,ch          { bit setted?                       }
            jz @noput
              mov es:[si],al    { yes: put pixel                    }
            @noput:
            inc si              { next pixel                        }
            jnc @noinc          { overflow?                         }
              pop ds
              pusha
              call incbank      { then switch to next bank          }
              popa
              push ds
              push bx
              lds bx,chp
              pop bx
            @noinc:
            add ch,ch           { next bit                          }
            dec cl              { x-Position im byte - eins weiter}
          jnz @lp               { am Ende vom Bit? Wenn nein: von vorne}
          add si,incer          { nchste Zeile}
          jnc @noinc2           { Ueberlauf?}
            pop ds
            pusha
            call incbank        { dann nchste Bank}
            popa
            push ds
            push bx
            lds bx,chp
            pop bx
            @noinc2:
            dec dh              { Y-Position erweitern}
        jnz @lp2                { Am Ende/Zeichen angekommen? Wenn nein- von neuem}
        pop ds
        @overmaxx:
        mov al,dist
        xor ah,ah
        add ax,dx
        add xwidth,ax           { und zur aktuellen X-Position addieren}
        mov ax,i                { I in AX laden..}
        inc ax                  { AX(I) erweitern..}
        mov i,ax                { und in I speichern}
        cmp al,byte ptr s[0]    { alle Zeichen im String abgearbeitet?}
      jne @lp3                  { Wenn nein- nchstes Zeichen}
     end;
   end;
 end else if header[font].colordepth = 8 then begin
   xwidth := x;
   chp    := chars[font];
   dist   := header[font].distance;

   for i := 0 to pred(ord(s[0])) do begin
     cr := ord(s[i+1]);
     px := memw[seg(chp^):ofs(chp^)+(cr-header[font].startchar)*2]+
     (header[font].endchar-header[font].startchar+1)*2;
     width := memw[seg(chp^):ofs(chp^)+px+2];
     if (cr <> 32)and(width > 0)and(cr >= header[font].startchar)
     and(cr <= header[font].endchar) then begin
       putsprite(xwidth,y,ptr(seg(chp^),ofs(chp^)+px+2));
       inc(xwidth,width+dist);
     end else
     inc(xwidth,header[font].width);
   end;
 end;
end;


function MyHeapErrorFunc(size: Word) : Integer;far;
begin
 if size = 0 then MyHeapErrorFUnc := 2
 else begin
   closegraph;
   writeln('Error: not enough memory (',size,' Bytes)');
   MyHeapErrorFunc := 1;
   halt(20);
 end;
end;


begin
 if not loadfontmem(@LITTN2,2)   then exit;
 if not loadfontmem(@SYSFONT2,0) then exit;
{if not loadfontmem(@ATRAX,1)    then exit;}
{if not loadfontmem(@SYS16x16,3) then exit;}
 HeapError := @MyHeapErrorFunc;
 New(Pal);
 s := 'VBE2';{tell the VESA-Driver you want extended information}
 move2(s,vesainfoblock.vesasignature[0],4);
 getvesainfo;
end.
{****************************************************************************
 * History                                                                  *
 * Version 1.0 : first public available Version (9th Aug.1997)              *
 * Version 1.1 : +added some comments so that other persons know how to use *
 *                the procedures                                            *
 *               +added circle-routines (filled and traced)                 *
 *               *fixed a bug in procedure sprite2mem                       *
 *               *fixed a bug in readgraphline                              *
 *               +added scrollsupport                                       *
 *               *changed the cursor in readgraphline to see it better      *
 *               +added special waitretrace for setvisualpage (pageretrace) *
 *                (12th Aug.1997)                                           *
 * Version 1.11 :*fixed some minor bugs                                     *
 * Version 1.2  :+added setviewport                                         *
 *                ^please note that there could be some little bugs - I had *
 *                 not enough time to check all out... you know: school     *
 +               +added vline                                               *
 *               *changed some things for PM - should run on S3 cards now   *
 *                faster and on other cards where it didn't run it runs now *
 *               +added some variables for compatibility with the unit graph*
 *               *graphics is now runable under TP6 without any changes     *
 *               *fixed a bug with a wrong variable that causes a terrible  *
 *                display on some special gfx-cards                         *
 *               *changed S3-Chip-detection because the detection detects   *
 *                sometimes not correctly                                   *
 *            thanx to Carsten Krger for his support with these 2 things   *
 *                (27th Sep.1997)                                           *
 * Version 1.21  *writexy-vectorscript module rewritten to assembler - is   *
 *                now nearly 2 times faster                                 *
 *               *fixed a bug in putimage and similar procedures            *
 *                bug was caused by the implementation of setviewport       *
 *                (28th Sep.1997)                                           *
 * Version 1.25  +added support for 8-Bit fonts                             *
 *               *fixed a little bug in circle-procedure                    *
 *               *fixed a bug in writexy which causes with 1bit font wrong  *
 *                display if the font wents over the right edge             *
 *               +1bit fonts are now clipped also on the left edges         *
 *                (3rd Oct.1997)                                            *
 ****************************************************************************}
