{$A+,B+,D-,E+,F-,G+,I-,L-,N-,O-,R-,S-,V-,X+}
unit s3speed;

interface

 procedure FAST_WRITE_BUFFER_ON;
 procedure MAP_A000H;

implementation

procedure Read3D4;assembler;
asm
 mov  dx,3d4h
 out  dx,al
 mov  ah,al
 inc  dx
 in   al,dx
 xchg ah,al
 dec  dx
end;

procedure Write3D4;assembler;
asm
 mov  dx,3d4h
 out  dx,al
 xchg ah,al
 inc  dx
 out  dx,al
 xchg ah,al
 dec  dx
end;

procedure ExtON;assembler;
asm
 mov  ax,4838h { extensions enable (enable extended registers)}
 call Write3D4 { write(3d4h, 38h, 48h) }
 mov  ax,0A039h{ extensions enable2    }
 call Write3D4 { write(3d4h, 39h, a0h) }
end;

procedure ExtOFF;assembler;
asm
 mov  ax,0038h { disable extended registers}
 call Write3D4 { write(3d4h, 38h, 00h)     }
 mov  ax,0039h { disable2                  }
 call Write3D4 { write(3d4h, 39h, 00h)     }
end;

procedure MAP_A000H;assembler;
asm
 pusha
 mov  bl,0ECh
 mov  bh,10h
 mov  cx,000Ah
 call ExtON   { enable extensions                }
 mov  al,058h { linear aperture options / bit 2  }
 call Read3D4 { ah = read(3d4h, 58h)             }
 and  ah,0ECh { clear bit 0,1 and 4              }
 call Write3D4{ write(3d4h, 58h, new AH)         }
 mov  al,059h { bit 0-1: linear memory address bit 8-9}
 mov  ah,ch
 call Write3D4{ write(3d4h, 59h, 00h)            }
 inc  al      { 05Ah : bit 0-7 = linear mem address bit 0-7}
 mov  ah,cl   { in 64k units ???                 }
 call Write3D4{ write(3d4h, 5Ah, 0Ah)            }
 mov  al,058h { linear aperture options          }
 call Read3D4 { ah = read(3d4h, 58h)             }
 and  ah,bl   { and ah,ECh -> clear bit 0,1 and 4}
 or   ah,bh   { or ah,10h (OR or ah,00h) -> set bit 4}
 call Write3D4{ write(3d4h, 58h, new AH)         }
 call ExtOFF  { disable extensions               }
 popa
end;

procedure FAST_WRITE_BUFFER_ON;assembler;
asm
 pusha
 call  ExtON   { enable extensions                              }
 mov   al,40h  { bit 0: if set enables 8514/A mode              }
 call  Read3D4 {   * 3: (801,805,928) Fast Write Buffer ON *    }
 or    ah,08h  {     6: (801,805,928) Zero Wait State OFF (EISA)}
 call  Write3D4{ set bit 3 to ON                                }
 call  ExtOFF  { disable extensions                             }
 popa
end;

{If you want to boost an SVGA mode banked, just type:

         call  MAP_A000h
         call  FAST_WRITE_BUFFER_ON

If you want to boost an SVGA mode FLAT linear, just type:

         call  FAST_WRITE_BUFFER_ON}
end.